package airec

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QuerySingleAggregationReport invokes the airec.QuerySingleAggregationReport API synchronously
// api document: https://help.aliyun.com/api/airec/querysingleaggregationreport.html
func (client *Client) QuerySingleAggregationReport(request *QuerySingleAggregationReportRequest) (response *QuerySingleAggregationReportResponse, err error) {
	response = CreateQuerySingleAggregationReportResponse()
	err = client.DoAction(request, response)
	return
}

// QuerySingleAggregationReportWithChan invokes the airec.QuerySingleAggregationReport API asynchronously
// api document: https://help.aliyun.com/api/airec/querysingleaggregationreport.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QuerySingleAggregationReportWithChan(request *QuerySingleAggregationReportRequest) (<-chan *QuerySingleAggregationReportResponse, <-chan error) {
	responseChan := make(chan *QuerySingleAggregationReportResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QuerySingleAggregationReport(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QuerySingleAggregationReportWithCallback invokes the airec.QuerySingleAggregationReport API asynchronously
// api document: https://help.aliyun.com/api/airec/querysingleaggregationreport.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QuerySingleAggregationReportWithCallback(request *QuerySingleAggregationReportRequest, callback func(response *QuerySingleAggregationReportResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QuerySingleAggregationReportResponse
		var err error
		defer close(result)
		response, err = client.QuerySingleAggregationReport(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QuerySingleAggregationReportRequest is the request struct for api QuerySingleAggregationReport
type QuerySingleAggregationReportRequest struct {
	*requests.RoaRequest
	InstanceId string `position:"Path" name:"InstanceId"`
}

// QuerySingleAggregationReportResponse is the response struct for api QuerySingleAggregationReport
type QuerySingleAggregationReportResponse struct {
	*responses.BaseResponse
	RequestId string                 `json:"RequestId" xml:"RequestId"`
	Code      string                 `json:"Code" xml:"Code"`
	Message   string                 `json:"Message" xml:"Message"`
	Result    map[string]interface{} `json:"Result" xml:"Result"`
}

// CreateQuerySingleAggregationReportRequest creates a request to invoke QuerySingleAggregationReport API
func CreateQuerySingleAggregationReportRequest() (request *QuerySingleAggregationReportRequest) {
	request = &QuerySingleAggregationReportRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("Airec", "2018-10-12", "QuerySingleAggregationReport", "/openapi/instances/[InstanceId]/sync-reports/single-aggregation-report", "airec", "openAPI")
	request.Method = requests.GET
	return
}

// CreateQuerySingleAggregationReportResponse creates a response to parse from QuerySingleAggregationReport response
func CreateQuerySingleAggregationReportResponse() (response *QuerySingleAggregationReportResponse) {
	response = &QuerySingleAggregationReportResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
