package aliyuncvc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ActiveMeetingCode invokes the aliyuncvc.ActiveMeetingCode API synchronously
// api document: https://help.aliyun.com/api/aliyuncvc/activemeetingcode.html
func (client *Client) ActiveMeetingCode(request *ActiveMeetingCodeRequest) (response *ActiveMeetingCodeResponse, err error) {
	response = CreateActiveMeetingCodeResponse()
	err = client.DoAction(request, response)
	return
}

// ActiveMeetingCodeWithChan invokes the aliyuncvc.ActiveMeetingCode API asynchronously
// api document: https://help.aliyun.com/api/aliyuncvc/activemeetingcode.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ActiveMeetingCodeWithChan(request *ActiveMeetingCodeRequest) (<-chan *ActiveMeetingCodeResponse, <-chan error) {
	responseChan := make(chan *ActiveMeetingCodeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ActiveMeetingCode(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ActiveMeetingCodeWithCallback invokes the aliyuncvc.ActiveMeetingCode API asynchronously
// api document: https://help.aliyun.com/api/aliyuncvc/activemeetingcode.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ActiveMeetingCodeWithCallback(request *ActiveMeetingCodeRequest, callback func(response *ActiveMeetingCodeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ActiveMeetingCodeResponse
		var err error
		defer close(result)
		response, err = client.ActiveMeetingCode(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ActiveMeetingCodeRequest is the request struct for api ActiveMeetingCode
type ActiveMeetingCodeRequest struct {
	*requests.RpcRequest
	MeetingUUID string `position:"Query" name:"MeetingUUID"`
	MeetingCode string `position:"Query" name:"MeetingCode"`
}

// ActiveMeetingCodeResponse is the response struct for api ActiveMeetingCode
type ActiveMeetingCodeResponse struct {
	*responses.BaseResponse
	ErrorCode   int         `json:"ErrorCode" xml:"ErrorCode"`
	Message     string      `json:"Message" xml:"Message"`
	Success     bool        `json:"Success" xml:"Success"`
	RequestId   string      `json:"RequestId" xml:"RequestId"`
	MeetingInfo MeetingInfo `json:"MeetingInfo" xml:"MeetingInfo"`
}

// CreateActiveMeetingCodeRequest creates a request to invoke ActiveMeetingCode API
func CreateActiveMeetingCodeRequest() (request *ActiveMeetingCodeRequest) {
	request = &ActiveMeetingCodeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("aliyuncvc", "2019-09-19", "ActiveMeetingCode", "aliyuncvc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateActiveMeetingCodeResponse creates a response to parse from ActiveMeetingCode response
func CreateActiveMeetingCodeResponse() (response *ActiveMeetingCodeResponse) {
	response = &ActiveMeetingCodeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
