package aliyuncvc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RemoveMeeting invokes the aliyuncvc.RemoveMeeting API synchronously
// api document: https://help.aliyun.com/api/aliyuncvc/removemeeting.html
func (client *Client) RemoveMeeting(request *RemoveMeetingRequest) (response *RemoveMeetingResponse, err error) {
	response = CreateRemoveMeetingResponse()
	err = client.DoAction(request, response)
	return
}

// RemoveMeetingWithChan invokes the aliyuncvc.RemoveMeeting API asynchronously
// api document: https://help.aliyun.com/api/aliyuncvc/removemeeting.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RemoveMeetingWithChan(request *RemoveMeetingRequest) (<-chan *RemoveMeetingResponse, <-chan error) {
	responseChan := make(chan *RemoveMeetingResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RemoveMeeting(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RemoveMeetingWithCallback invokes the aliyuncvc.RemoveMeeting API asynchronously
// api document: https://help.aliyun.com/api/aliyuncvc/removemeeting.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RemoveMeetingWithCallback(request *RemoveMeetingRequest, callback func(response *RemoveMeetingResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RemoveMeetingResponse
		var err error
		defer close(result)
		response, err = client.RemoveMeeting(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RemoveMeetingRequest is the request struct for api RemoveMeeting
type RemoveMeetingRequest struct {
	*requests.RpcRequest
	MeetingUUID string `position:"Body" name:"MeetingUUID"`
}

// RemoveMeetingResponse is the response struct for api RemoveMeeting
type RemoveMeetingResponse struct {
	*responses.BaseResponse
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	Message   string `json:"Message" xml:"Message"`
	Success   bool   `json:"Success" xml:"Success"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRemoveMeetingRequest creates a request to invoke RemoveMeeting API
func CreateRemoveMeetingRequest() (request *RemoveMeetingRequest) {
	request = &RemoveMeetingRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("aliyuncvc", "2019-09-19", "RemoveMeeting", "aliyuncvc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRemoveMeetingResponse creates a response to parse from RemoveMeeting response
func CreateRemoveMeetingResponse() (response *RemoveMeetingResponse) {
	response = &RemoveMeetingResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
