package arms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListPromClusters invokes the arms.ListPromClusters API synchronously
// api document: https://help.aliyun.com/api/arms/listpromclusters.html
func (client *Client) ListPromClusters(request *ListPromClustersRequest) (response *ListPromClustersResponse, err error) {
	response = CreateListPromClustersResponse()
	err = client.DoAction(request, response)
	return
}

// ListPromClustersWithChan invokes the arms.ListPromClusters API asynchronously
// api document: https://help.aliyun.com/api/arms/listpromclusters.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListPromClustersWithChan(request *ListPromClustersRequest) (<-chan *ListPromClustersResponse, <-chan error) {
	responseChan := make(chan *ListPromClustersResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListPromClusters(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListPromClustersWithCallback invokes the arms.ListPromClusters API asynchronously
// api document: https://help.aliyun.com/api/arms/listpromclusters.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListPromClustersWithCallback(request *ListPromClustersRequest, callback func(response *ListPromClustersResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListPromClustersResponse
		var err error
		defer close(result)
		response, err = client.ListPromClusters(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListPromClustersRequest is the request struct for api ListPromClusters
type ListPromClustersRequest struct {
	*requests.RpcRequest
}

// ListPromClustersResponse is the response struct for api ListPromClusters
type ListPromClustersResponse struct {
	*responses.BaseResponse
	RequestId       string        `json:"RequestId" xml:"RequestId"`
	PromClusterList []PromCluster `json:"PromClusterList" xml:"PromClusterList"`
}

// CreateListPromClustersRequest creates a request to invoke ListPromClusters API
func CreateListPromClustersRequest() (request *ListPromClustersRequest) {
	request = &ListPromClustersRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS", "2019-08-08", "ListPromClusters", "arms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListPromClustersResponse creates a response to parse from ListPromClusters response
func CreateListPromClustersResponse() (response *ListPromClustersResponse) {
	response = &ListPromClustersResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
