package cloudesl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AssociatePlanogramRail invokes the cloudesl.AssociatePlanogramRail API synchronously
// api document: https://help.aliyun.com/api/cloudesl/associateplanogramrail.html
func (client *Client) AssociatePlanogramRail(request *AssociatePlanogramRailRequest) (response *AssociatePlanogramRailResponse, err error) {
	response = CreateAssociatePlanogramRailResponse()
	err = client.DoAction(request, response)
	return
}

// AssociatePlanogramRailWithChan invokes the cloudesl.AssociatePlanogramRail API asynchronously
// api document: https://help.aliyun.com/api/cloudesl/associateplanogramrail.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) AssociatePlanogramRailWithChan(request *AssociatePlanogramRailRequest) (<-chan *AssociatePlanogramRailResponse, <-chan error) {
	responseChan := make(chan *AssociatePlanogramRailResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AssociatePlanogramRail(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AssociatePlanogramRailWithCallback invokes the cloudesl.AssociatePlanogramRail API asynchronously
// api document: https://help.aliyun.com/api/cloudesl/associateplanogramrail.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) AssociatePlanogramRailWithCallback(request *AssociatePlanogramRailRequest, callback func(response *AssociatePlanogramRailResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AssociatePlanogramRailResponse
		var err error
		defer close(result)
		response, err = client.AssociatePlanogramRail(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AssociatePlanogramRailRequest is the request struct for api AssociatePlanogramRail
type AssociatePlanogramRailRequest struct {
	*requests.RpcRequest
	StoreId  string           `position:"Body" name:"StoreId"`
	Layer    requests.Integer `position:"Body" name:"Layer"`
	Shelf    string           `position:"Body" name:"Shelf"`
	RailCode string           `position:"Body" name:"RailCode"`
}

// AssociatePlanogramRailResponse is the response struct for api AssociatePlanogramRail
type AssociatePlanogramRailResponse struct {
	*responses.BaseResponse
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	Message        string `json:"Message" xml:"Message"`
	DynamicCode    string `json:"DynamicCode" xml:"DynamicCode"`
	Code           string `json:"Code" xml:"Code"`
	DynamicMessage string `json:"DynamicMessage" xml:"DynamicMessage"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
}

// CreateAssociatePlanogramRailRequest creates a request to invoke AssociatePlanogramRail API
func CreateAssociatePlanogramRailRequest() (request *AssociatePlanogramRailRequest) {
	request = &AssociatePlanogramRailRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudesl", "2020-02-01", "AssociatePlanogramRail", "cloudesl", "openAPI")
	return
}

// CreateAssociatePlanogramRailResponse creates a response to parse from AssociatePlanogramRail response
func CreateAssociatePlanogramRailResponse() (response *AssociatePlanogramRailResponse) {
	response = &AssociatePlanogramRailResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
