package cloudesl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DissociatePlanogramRail invokes the cloudesl.DissociatePlanogramRail API synchronously
// api document: https://help.aliyun.com/api/cloudesl/dissociateplanogramrail.html
func (client *Client) DissociatePlanogramRail(request *DissociatePlanogramRailRequest) (response *DissociatePlanogramRailResponse, err error) {
	response = CreateDissociatePlanogramRailResponse()
	err = client.DoAction(request, response)
	return
}

// DissociatePlanogramRailWithChan invokes the cloudesl.DissociatePlanogramRail API asynchronously
// api document: https://help.aliyun.com/api/cloudesl/dissociateplanogramrail.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DissociatePlanogramRailWithChan(request *DissociatePlanogramRailRequest) (<-chan *DissociatePlanogramRailResponse, <-chan error) {
	responseChan := make(chan *DissociatePlanogramRailResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DissociatePlanogramRail(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DissociatePlanogramRailWithCallback invokes the cloudesl.DissociatePlanogramRail API asynchronously
// api document: https://help.aliyun.com/api/cloudesl/dissociateplanogramrail.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DissociatePlanogramRailWithCallback(request *DissociatePlanogramRailRequest, callback func(response *DissociatePlanogramRailResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DissociatePlanogramRailResponse
		var err error
		defer close(result)
		response, err = client.DissociatePlanogramRail(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DissociatePlanogramRailRequest is the request struct for api DissociatePlanogramRail
type DissociatePlanogramRailRequest struct {
	*requests.RpcRequest
	StoreId  string `position:"Body" name:"StoreId"`
	RailCode string `position:"Body" name:"RailCode"`
}

// DissociatePlanogramRailResponse is the response struct for api DissociatePlanogramRail
type DissociatePlanogramRailResponse struct {
	*responses.BaseResponse
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	Message        string `json:"Message" xml:"Message"`
	DynamicCode    string `json:"DynamicCode" xml:"DynamicCode"`
	Code           string `json:"Code" xml:"Code"`
	DynamicMessage string `json:"DynamicMessage" xml:"DynamicMessage"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
}

// CreateDissociatePlanogramRailRequest creates a request to invoke DissociatePlanogramRail API
func CreateDissociatePlanogramRailRequest() (request *DissociatePlanogramRailRequest) {
	request = &DissociatePlanogramRailRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudesl", "2020-02-01", "DissociatePlanogramRail", "cloudesl", "openAPI")
	return
}

// CreateDissociatePlanogramRailResponse creates a response to parse from DissociatePlanogramRail response
func CreateDissociatePlanogramRailResponse() (response *DissociatePlanogramRailResponse) {
	response = &DissociatePlanogramRailResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
