package cs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CancelComponentUpgrade invokes the cs.CancelComponentUpgrade API synchronously
// api document: https://help.aliyun.com/api/cs/cancelcomponentupgrade.html
func (client *Client) CancelComponentUpgrade(request *CancelComponentUpgradeRequest) (response *CancelComponentUpgradeResponse, err error) {
	response = CreateCancelComponentUpgradeResponse()
	err = client.DoAction(request, response)
	return
}

// CancelComponentUpgradeWithChan invokes the cs.CancelComponentUpgrade API asynchronously
// api document: https://help.aliyun.com/api/cs/cancelcomponentupgrade.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CancelComponentUpgradeWithChan(request *CancelComponentUpgradeRequest) (<-chan *CancelComponentUpgradeResponse, <-chan error) {
	responseChan := make(chan *CancelComponentUpgradeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CancelComponentUpgrade(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CancelComponentUpgradeWithCallback invokes the cs.CancelComponentUpgrade API asynchronously
// api document: https://help.aliyun.com/api/cs/cancelcomponentupgrade.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CancelComponentUpgradeWithCallback(request *CancelComponentUpgradeRequest, callback func(response *CancelComponentUpgradeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CancelComponentUpgradeResponse
		var err error
		defer close(result)
		response, err = client.CancelComponentUpgrade(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CancelComponentUpgradeRequest is the request struct for api CancelComponentUpgrade
type CancelComponentUpgradeRequest struct {
	*requests.RoaRequest
	Componentid string `position:"Path" name:"componentid"`
	Clusterid   string `position:"Path" name:"clusterid"`
}

// CancelComponentUpgradeResponse is the response struct for api CancelComponentUpgrade
type CancelComponentUpgradeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCancelComponentUpgradeRequest creates a request to invoke CancelComponentUpgrade API
func CreateCancelComponentUpgradeRequest() (request *CancelComponentUpgradeRequest) {
	request = &CancelComponentUpgradeRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("CS", "2015-12-15", "CancelComponentUpgrade", "/clusters/[clusterid]/components/[componentid]/cancel", "", "")
	request.Method = requests.POST
	return
}

// CreateCancelComponentUpgradeResponse creates a response to parse from CancelComponentUpgrade response
func CreateCancelComponentUpgradeResponse() (response *CancelComponentUpgradeResponse) {
	response = &CancelComponentUpgradeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
