package cs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteTriggerHook invokes the cs.DeleteTriggerHook API synchronously
// api document: https://help.aliyun.com/api/cs/deletetriggerhook.html
func (client *Client) DeleteTriggerHook(request *DeleteTriggerHookRequest) (response *DeleteTriggerHookResponse, err error) {
	response = CreateDeleteTriggerHookResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteTriggerHookWithChan invokes the cs.DeleteTriggerHook API asynchronously
// api document: https://help.aliyun.com/api/cs/deletetriggerhook.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteTriggerHookWithChan(request *DeleteTriggerHookRequest) (<-chan *DeleteTriggerHookResponse, <-chan error) {
	responseChan := make(chan *DeleteTriggerHookResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteTriggerHook(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteTriggerHookWithCallback invokes the cs.DeleteTriggerHook API asynchronously
// api document: https://help.aliyun.com/api/cs/deletetriggerhook.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteTriggerHookWithCallback(request *DeleteTriggerHookRequest, callback func(response *DeleteTriggerHookResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteTriggerHookResponse
		var err error
		defer close(result)
		response, err = client.DeleteTriggerHook(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteTriggerHookRequest is the request struct for api DeleteTriggerHook
type DeleteTriggerHookRequest struct {
	*requests.RoaRequest
}

// DeleteTriggerHookResponse is the response struct for api DeleteTriggerHook
type DeleteTriggerHookResponse struct {
	*responses.BaseResponse
}

// CreateDeleteTriggerHookRequest creates a request to invoke DeleteTriggerHook API
func CreateDeleteTriggerHookRequest() (request *DeleteTriggerHookRequest) {
	request = &DeleteTriggerHookRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("CS", "2015-12-15", "DeleteTriggerHook", "/api/v2/hook/trigger", "", "")
	request.Method = requests.POST
	return
}

// CreateDeleteTriggerHookResponse creates a response to parse from DeleteTriggerHook response
func CreateDeleteTriggerHookResponse() (response *DeleteTriggerHookResponse) {
	response = &DeleteTriggerHookResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
