package cs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RemoveWorkflow invokes the cs.RemoveWorkflow API synchronously
// api document: https://help.aliyun.com/api/cs/removeworkflow.html
func (client *Client) RemoveWorkflow(request *RemoveWorkflowRequest) (response *RemoveWorkflowResponse, err error) {
	response = CreateRemoveWorkflowResponse()
	err = client.DoAction(request, response)
	return
}

// RemoveWorkflowWithChan invokes the cs.RemoveWorkflow API asynchronously
// api document: https://help.aliyun.com/api/cs/removeworkflow.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RemoveWorkflowWithChan(request *RemoveWorkflowRequest) (<-chan *RemoveWorkflowResponse, <-chan error) {
	responseChan := make(chan *RemoveWorkflowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RemoveWorkflow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RemoveWorkflowWithCallback invokes the cs.RemoveWorkflow API asynchronously
// api document: https://help.aliyun.com/api/cs/removeworkflow.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RemoveWorkflowWithCallback(request *RemoveWorkflowRequest, callback func(response *RemoveWorkflowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RemoveWorkflowResponse
		var err error
		defer close(result)
		response, err = client.RemoveWorkflow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RemoveWorkflowRequest is the request struct for api RemoveWorkflow
type RemoveWorkflowRequest struct {
	*requests.RoaRequest
	WorkflowName string `position:"Path" name:"workflowName"`
}

// RemoveWorkflowResponse is the response struct for api RemoveWorkflow
type RemoveWorkflowResponse struct {
	*responses.BaseResponse
}

// CreateRemoveWorkflowRequest creates a request to invoke RemoveWorkflow API
func CreateRemoveWorkflowRequest() (request *RemoveWorkflowRequest) {
	request = &RemoveWorkflowRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("CS", "2015-12-15", "RemoveWorkflow", "/gs/workflow/[workflowName]", "", "")
	request.Method = requests.DELETE
	return
}

// CreateRemoveWorkflowResponse creates a response to parse from RemoveWorkflow response
func CreateRemoveWorkflowResponse() (response *RemoveWorkflowResponse) {
	response = &RemoveWorkflowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
