package cs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StartWorkflow invokes the cs.StartWorkflow API synchronously
// api document: https://help.aliyun.com/api/cs/startworkflow.html
func (client *Client) StartWorkflow(request *StartWorkflowRequest) (response *StartWorkflowResponse, err error) {
	response = CreateStartWorkflowResponse()
	err = client.DoAction(request, response)
	return
}

// StartWorkflowWithChan invokes the cs.StartWorkflow API asynchronously
// api document: https://help.aliyun.com/api/cs/startworkflow.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StartWorkflowWithChan(request *StartWorkflowRequest) (<-chan *StartWorkflowResponse, <-chan error) {
	responseChan := make(chan *StartWorkflowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StartWorkflow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StartWorkflowWithCallback invokes the cs.StartWorkflow API asynchronously
// api document: https://help.aliyun.com/api/cs/startworkflow.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StartWorkflowWithCallback(request *StartWorkflowRequest, callback func(response *StartWorkflowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StartWorkflowResponse
		var err error
		defer close(result)
		response, err = client.StartWorkflow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StartWorkflowRequest is the request struct for api StartWorkflow
type StartWorkflowRequest struct {
	*requests.RoaRequest
}

// StartWorkflowResponse is the response struct for api StartWorkflow
type StartWorkflowResponse struct {
	*responses.BaseResponse
}

// CreateStartWorkflowRequest creates a request to invoke StartWorkflow API
func CreateStartWorkflowRequest() (request *StartWorkflowRequest) {
	request = &StartWorkflowRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("CS", "2015-12-15", "StartWorkflow", "/gs/workflow", "", "")
	request.Method = requests.POST
	return
}

// CreateStartWorkflowResponse creates a response to parse from StartWorkflow response
func CreateStartWorkflowResponse() (response *StartWorkflowResponse) {
	response = &StartWorkflowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
