package cs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateK8sClusterUserConfigExpire invokes the cs.UpdateK8sClusterUserConfigExpire API synchronously
// api document: https://help.aliyun.com/api/cs/updatek8sclusteruserconfigexpire.html
func (client *Client) UpdateK8sClusterUserConfigExpire(request *UpdateK8sClusterUserConfigExpireRequest) (response *UpdateK8sClusterUserConfigExpireResponse, err error) {
	response = CreateUpdateK8sClusterUserConfigExpireResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateK8sClusterUserConfigExpireWithChan invokes the cs.UpdateK8sClusterUserConfigExpire API asynchronously
// api document: https://help.aliyun.com/api/cs/updatek8sclusteruserconfigexpire.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UpdateK8sClusterUserConfigExpireWithChan(request *UpdateK8sClusterUserConfigExpireRequest) (<-chan *UpdateK8sClusterUserConfigExpireResponse, <-chan error) {
	responseChan := make(chan *UpdateK8sClusterUserConfigExpireResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateK8sClusterUserConfigExpire(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateK8sClusterUserConfigExpireWithCallback invokes the cs.UpdateK8sClusterUserConfigExpire API asynchronously
// api document: https://help.aliyun.com/api/cs/updatek8sclusteruserconfigexpire.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UpdateK8sClusterUserConfigExpireWithCallback(request *UpdateK8sClusterUserConfigExpireRequest, callback func(response *UpdateK8sClusterUserConfigExpireResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateK8sClusterUserConfigExpireResponse
		var err error
		defer close(result)
		response, err = client.UpdateK8sClusterUserConfigExpire(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateK8sClusterUserConfigExpireRequest is the request struct for api UpdateK8sClusterUserConfigExpire
type UpdateK8sClusterUserConfigExpireRequest struct {
	*requests.RoaRequest
	ClusterId string `position:"Path" name:"ClusterId"`
}

// UpdateK8sClusterUserConfigExpireResponse is the response struct for api UpdateK8sClusterUserConfigExpire
type UpdateK8sClusterUserConfigExpireResponse struct {
	*responses.BaseResponse
}

// CreateUpdateK8sClusterUserConfigExpireRequest creates a request to invoke UpdateK8sClusterUserConfigExpire API
func CreateUpdateK8sClusterUserConfigExpireRequest() (request *UpdateK8sClusterUserConfigExpireRequest) {
	request = &UpdateK8sClusterUserConfigExpireRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("CS", "2015-12-15", "UpdateK8sClusterUserConfigExpire", "/k8s/[ClusterId]/user_config/expire", "", "")
	request.Method = requests.POST
	return
}

// CreateUpdateK8sClusterUserConfigExpireResponse creates a response to parse from UpdateK8sClusterUserConfigExpire response
func CreateUpdateK8sClusterUserConfigExpireResponse() (response *UpdateK8sClusterUserConfigExpireResponse) {
	response = &UpdateK8sClusterUserConfigExpireResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
