package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ConfigWebCCTemplate invokes the ddoscoo.ConfigWebCCTemplate API synchronously
// api document: https://help.aliyun.com/api/ddoscoo/configwebcctemplate.html
func (client *Client) ConfigWebCCTemplate(request *ConfigWebCCTemplateRequest) (response *ConfigWebCCTemplateResponse, err error) {
	response = CreateConfigWebCCTemplateResponse()
	err = client.DoAction(request, response)
	return
}

// ConfigWebCCTemplateWithChan invokes the ddoscoo.ConfigWebCCTemplate API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/configwebcctemplate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ConfigWebCCTemplateWithChan(request *ConfigWebCCTemplateRequest) (<-chan *ConfigWebCCTemplateResponse, <-chan error) {
	responseChan := make(chan *ConfigWebCCTemplateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ConfigWebCCTemplate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ConfigWebCCTemplateWithCallback invokes the ddoscoo.ConfigWebCCTemplate API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/configwebcctemplate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ConfigWebCCTemplateWithCallback(request *ConfigWebCCTemplateRequest, callback func(response *ConfigWebCCTemplateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ConfigWebCCTemplateResponse
		var err error
		defer close(result)
		response, err = client.ConfigWebCCTemplate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ConfigWebCCTemplateRequest is the request struct for api ConfigWebCCTemplate
type ConfigWebCCTemplateRequest struct {
	*requests.RpcRequest
	Template        string `position:"Query" name:"Template"`
	ResourceGroupId string `position:"Query" name:"ResourceGroupId"`
	SourceIp        string `position:"Query" name:"SourceIp"`
	Domain          string `position:"Query" name:"Domain"`
}

// ConfigWebCCTemplateResponse is the response struct for api ConfigWebCCTemplate
type ConfigWebCCTemplateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateConfigWebCCTemplateRequest creates a request to invoke ConfigWebCCTemplate API
func CreateConfigWebCCTemplateRequest() (request *ConfigWebCCTemplateRequest) {
	request = &ConfigWebCCTemplateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2020-01-01", "ConfigWebCCTemplate", "ddoscoo", "openAPI")
	return
}

// CreateConfigWebCCTemplateResponse creates a response to parse from ConfigWebCCTemplate response
func CreateConfigWebCCTemplateResponse() (response *ConfigWebCCTemplateResponse) {
	response = &ConfigWebCCTemplateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
