package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteAutoCcBlacklist invokes the ddoscoo.DeleteAutoCcBlacklist API synchronously
// api document: https://help.aliyun.com/api/ddoscoo/deleteautoccblacklist.html
func (client *Client) DeleteAutoCcBlacklist(request *DeleteAutoCcBlacklistRequest) (response *DeleteAutoCcBlacklistResponse, err error) {
	response = CreateDeleteAutoCcBlacklistResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteAutoCcBlacklistWithChan invokes the ddoscoo.DeleteAutoCcBlacklist API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/deleteautoccblacklist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteAutoCcBlacklistWithChan(request *DeleteAutoCcBlacklistRequest) (<-chan *DeleteAutoCcBlacklistResponse, <-chan error) {
	responseChan := make(chan *DeleteAutoCcBlacklistResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteAutoCcBlacklist(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteAutoCcBlacklistWithCallback invokes the ddoscoo.DeleteAutoCcBlacklist API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/deleteautoccblacklist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteAutoCcBlacklistWithCallback(request *DeleteAutoCcBlacklistRequest, callback func(response *DeleteAutoCcBlacklistResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteAutoCcBlacklistResponse
		var err error
		defer close(result)
		response, err = client.DeleteAutoCcBlacklist(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteAutoCcBlacklistRequest is the request struct for api DeleteAutoCcBlacklist
type DeleteAutoCcBlacklistRequest struct {
	*requests.RpcRequest
	Blacklist  string `position:"Query" name:"Blacklist"`
	InstanceId string `position:"Query" name:"InstanceId"`
	SourceIp   string `position:"Query" name:"SourceIp"`
}

// DeleteAutoCcBlacklistResponse is the response struct for api DeleteAutoCcBlacklist
type DeleteAutoCcBlacklistResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteAutoCcBlacklistRequest creates a request to invoke DeleteAutoCcBlacklist API
func CreateDeleteAutoCcBlacklistRequest() (request *DeleteAutoCcBlacklistRequest) {
	request = &DeleteAutoCcBlacklistRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2020-01-01", "DeleteAutoCcBlacklist", "ddoscoo", "openAPI")
	return
}

// CreateDeleteAutoCcBlacklistResponse creates a response to parse from DeleteAutoCcBlacklist response
func CreateDeleteAutoCcBlacklistResponse() (response *DeleteAutoCcBlacklistResponse) {
	response = &DeleteAutoCcBlacklistResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
