package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDomainOverview invokes the ddoscoo.DescribeDomainOverview API synchronously
// api document: https://help.aliyun.com/api/ddoscoo/describedomainoverview.html
func (client *Client) DescribeDomainOverview(request *DescribeDomainOverviewRequest) (response *DescribeDomainOverviewResponse, err error) {
	response = CreateDescribeDomainOverviewResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDomainOverviewWithChan invokes the ddoscoo.DescribeDomainOverview API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/describedomainoverview.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDomainOverviewWithChan(request *DescribeDomainOverviewRequest) (<-chan *DescribeDomainOverviewResponse, <-chan error) {
	responseChan := make(chan *DescribeDomainOverviewResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDomainOverview(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDomainOverviewWithCallback invokes the ddoscoo.DescribeDomainOverview API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/describedomainoverview.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDomainOverviewWithCallback(request *DescribeDomainOverviewRequest, callback func(response *DescribeDomainOverviewResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDomainOverviewResponse
		var err error
		defer close(result)
		response, err = client.DescribeDomainOverview(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDomainOverviewRequest is the request struct for api DescribeDomainOverview
type DescribeDomainOverviewRequest struct {
	*requests.RpcRequest
	EndTime         requests.Integer `position:"Query" name:"EndTime"`
	StartTime       requests.Integer `position:"Query" name:"StartTime"`
	ResourceGroupId string           `position:"Query" name:"ResourceGroupId"`
	SourceIp        string           `position:"Query" name:"SourceIp"`
	Domain          string           `position:"Query" name:"Domain"`
}

// DescribeDomainOverviewResponse is the response struct for api DescribeDomainOverview
type DescribeDomainOverviewResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	MaxHttps  int64  `json:"MaxHttps" xml:"MaxHttps"`
	MaxHttp   int64  `json:"MaxHttp" xml:"MaxHttp"`
}

// CreateDescribeDomainOverviewRequest creates a request to invoke DescribeDomainOverview API
func CreateDescribeDomainOverviewRequest() (request *DescribeDomainOverviewRequest) {
	request = &DescribeDomainOverviewRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2020-01-01", "DescribeDomainOverview", "ddoscoo", "openAPI")
	return
}

// CreateDescribeDomainOverviewResponse creates a response to parse from DescribeDomainOverview response
func CreateDescribeDomainOverviewResponse() (response *DescribeDomainOverviewResponse) {
	response = &DescribeDomainOverviewResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
