package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeWebCacheConfigs invokes the ddoscoo.DescribeWebCacheConfigs API synchronously
// api document: https://help.aliyun.com/api/ddoscoo/describewebcacheconfigs.html
func (client *Client) DescribeWebCacheConfigs(request *DescribeWebCacheConfigsRequest) (response *DescribeWebCacheConfigsResponse, err error) {
	response = CreateDescribeWebCacheConfigsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeWebCacheConfigsWithChan invokes the ddoscoo.DescribeWebCacheConfigs API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/describewebcacheconfigs.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeWebCacheConfigsWithChan(request *DescribeWebCacheConfigsRequest) (<-chan *DescribeWebCacheConfigsResponse, <-chan error) {
	responseChan := make(chan *DescribeWebCacheConfigsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeWebCacheConfigs(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeWebCacheConfigsWithCallback invokes the ddoscoo.DescribeWebCacheConfigs API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/describewebcacheconfigs.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeWebCacheConfigsWithCallback(request *DescribeWebCacheConfigsRequest, callback func(response *DescribeWebCacheConfigsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeWebCacheConfigsResponse
		var err error
		defer close(result)
		response, err = client.DescribeWebCacheConfigs(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeWebCacheConfigsRequest is the request struct for api DescribeWebCacheConfigs
type DescribeWebCacheConfigsRequest struct {
	*requests.RpcRequest
	Domains         *[]string `position:"Query" name:"Domains"  type:"Repeated"`
	ResourceGroupId string    `position:"Query" name:"ResourceGroupId"`
	SourceIp        string    `position:"Query" name:"SourceIp"`
}

// DescribeWebCacheConfigsResponse is the response struct for api DescribeWebCacheConfigs
type DescribeWebCacheConfigsResponse struct {
	*responses.BaseResponse
	RequestId          string        `json:"RequestId" xml:"RequestId"`
	DomainCacheConfigs []CacheConfig `json:"DomainCacheConfigs" xml:"DomainCacheConfigs"`
}

// CreateDescribeWebCacheConfigsRequest creates a request to invoke DescribeWebCacheConfigs API
func CreateDescribeWebCacheConfigsRequest() (request *DescribeWebCacheConfigsRequest) {
	request = &DescribeWebCacheConfigsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2020-01-01", "DescribeWebCacheConfigs", "ddoscoo", "openAPI")
	return
}

// CreateDescribeWebCacheConfigsResponse creates a response to parse from DescribeWebCacheConfigs response
func CreateDescribeWebCacheConfigsResponse() (response *DescribeWebCacheConfigsResponse) {
	response = &DescribeWebCacheConfigsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
