package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyWebAccessMode invokes the ddoscoo.ModifyWebAccessMode API synchronously
// api document: https://help.aliyun.com/api/ddoscoo/modifywebaccessmode.html
func (client *Client) ModifyWebAccessMode(request *ModifyWebAccessModeRequest) (response *ModifyWebAccessModeResponse, err error) {
	response = CreateModifyWebAccessModeResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyWebAccessModeWithChan invokes the ddoscoo.ModifyWebAccessMode API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/modifywebaccessmode.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyWebAccessModeWithChan(request *ModifyWebAccessModeRequest) (<-chan *ModifyWebAccessModeResponse, <-chan error) {
	responseChan := make(chan *ModifyWebAccessModeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyWebAccessMode(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyWebAccessModeWithCallback invokes the ddoscoo.ModifyWebAccessMode API asynchronously
// api document: https://help.aliyun.com/api/ddoscoo/modifywebaccessmode.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyWebAccessModeWithCallback(request *ModifyWebAccessModeRequest, callback func(response *ModifyWebAccessModeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyWebAccessModeResponse
		var err error
		defer close(result)
		response, err = client.ModifyWebAccessMode(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyWebAccessModeRequest is the request struct for api ModifyWebAccessMode
type ModifyWebAccessModeRequest struct {
	*requests.RpcRequest
	SourceIp   string           `position:"Query" name:"SourceIp"`
	Domain     string           `position:"Query" name:"Domain"`
	AccessMode requests.Integer `position:"Query" name:"AccessMode"`
}

// ModifyWebAccessModeResponse is the response struct for api ModifyWebAccessMode
type ModifyWebAccessModeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyWebAccessModeRequest creates a request to invoke ModifyWebAccessMode API
func CreateModifyWebAccessModeRequest() (request *ModifyWebAccessModeRequest) {
	request = &ModifyWebAccessModeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2020-01-01", "ModifyWebAccessMode", "ddoscoo", "openAPI")
	return
}

// CreateModifyWebAccessModeResponse creates a response to parse from ModifyWebAccessMode response
func CreateModifyWebAccessModeResponse() (response *ModifyWebAccessModeResponse) {
	response = &ModifyWebAccessModeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
