package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateCustomDataImportPreCheckTask invokes the drds.CreateCustomDataImportPreCheckTask API synchronously
// api document: https://help.aliyun.com/api/drds/createcustomdataimportprechecktask.html
func (client *Client) CreateCustomDataImportPreCheckTask(request *CreateCustomDataImportPreCheckTaskRequest) (response *CreateCustomDataImportPreCheckTaskResponse, err error) {
	response = CreateCreateCustomDataImportPreCheckTaskResponse()
	err = client.DoAction(request, response)
	return
}

// CreateCustomDataImportPreCheckTaskWithChan invokes the drds.CreateCustomDataImportPreCheckTask API asynchronously
// api document: https://help.aliyun.com/api/drds/createcustomdataimportprechecktask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateCustomDataImportPreCheckTaskWithChan(request *CreateCustomDataImportPreCheckTaskRequest) (<-chan *CreateCustomDataImportPreCheckTaskResponse, <-chan error) {
	responseChan := make(chan *CreateCustomDataImportPreCheckTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateCustomDataImportPreCheckTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateCustomDataImportPreCheckTaskWithCallback invokes the drds.CreateCustomDataImportPreCheckTask API asynchronously
// api document: https://help.aliyun.com/api/drds/createcustomdataimportprechecktask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateCustomDataImportPreCheckTaskWithCallback(request *CreateCustomDataImportPreCheckTaskRequest, callback func(response *CreateCustomDataImportPreCheckTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateCustomDataImportPreCheckTaskResponse
		var err error
		defer close(result)
		response, err = client.CreateCustomDataImportPreCheckTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateCustomDataImportPreCheckTaskRequest is the request struct for api CreateCustomDataImportPreCheckTask
type CreateCustomDataImportPreCheckTaskRequest struct {
	*requests.RpcRequest
	ImportParam string `position:"Query" name:"ImportParam"`
}

// CreateCustomDataImportPreCheckTaskResponse is the response struct for api CreateCustomDataImportPreCheckTask
type CreateCustomDataImportPreCheckTaskResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	TaskId    int64  `json:"TaskId" xml:"TaskId"`
}

// CreateCreateCustomDataImportPreCheckTaskRequest creates a request to invoke CreateCustomDataImportPreCheckTask API
func CreateCreateCustomDataImportPreCheckTaskRequest() (request *CreateCustomDataImportPreCheckTaskRequest) {
	request = &CreateCustomDataImportPreCheckTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "CreateCustomDataImportPreCheckTask", "Drds", "openAPI")
	return
}

// CreateCreateCustomDataImportPreCheckTaskResponse creates a response to parse from CreateCustomDataImportPreCheckTask response
func CreateCreateCustomDataImportPreCheckTaskResponse() (response *CreateCustomDataImportPreCheckTaskResponse) {
	response = &CreateCustomDataImportPreCheckTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
