package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeCustomDataImportSrcDstTables invokes the drds.DescribeCustomDataImportSrcDstTables API synchronously
// api document: https://help.aliyun.com/api/drds/describecustomdataimportsrcdsttables.html
func (client *Client) DescribeCustomDataImportSrcDstTables(request *DescribeCustomDataImportSrcDstTablesRequest) (response *DescribeCustomDataImportSrcDstTablesResponse, err error) {
	response = CreateDescribeCustomDataImportSrcDstTablesResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeCustomDataImportSrcDstTablesWithChan invokes the drds.DescribeCustomDataImportSrcDstTables API asynchronously
// api document: https://help.aliyun.com/api/drds/describecustomdataimportsrcdsttables.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCustomDataImportSrcDstTablesWithChan(request *DescribeCustomDataImportSrcDstTablesRequest) (<-chan *DescribeCustomDataImportSrcDstTablesResponse, <-chan error) {
	responseChan := make(chan *DescribeCustomDataImportSrcDstTablesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeCustomDataImportSrcDstTables(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeCustomDataImportSrcDstTablesWithCallback invokes the drds.DescribeCustomDataImportSrcDstTables API asynchronously
// api document: https://help.aliyun.com/api/drds/describecustomdataimportsrcdsttables.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCustomDataImportSrcDstTablesWithCallback(request *DescribeCustomDataImportSrcDstTablesRequest, callback func(response *DescribeCustomDataImportSrcDstTablesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeCustomDataImportSrcDstTablesResponse
		var err error
		defer close(result)
		response, err = client.DescribeCustomDataImportSrcDstTables(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeCustomDataImportSrcDstTablesRequest is the request struct for api DescribeCustomDataImportSrcDstTables
type DescribeCustomDataImportSrcDstTablesRequest struct {
	*requests.RpcRequest
	ImportParam string `position:"Query" name:"ImportParam"`
}

// DescribeCustomDataImportSrcDstTablesResponse is the response struct for api DescribeCustomDataImportSrcDstTables
type DescribeCustomDataImportSrcDstTablesResponse struct {
	*responses.BaseResponse
	RequestId              string                 `json:"RequestId" xml:"RequestId"`
	Success                bool                   `json:"Success" xml:"Success"`
	DataImportSrcDstTables DataImportSrcDstTables `json:"DataImportSrcDstTables" xml:"DataImportSrcDstTables"`
}

// CreateDescribeCustomDataImportSrcDstTablesRequest creates a request to invoke DescribeCustomDataImportSrcDstTables API
func CreateDescribeCustomDataImportSrcDstTablesRequest() (request *DescribeCustomDataImportSrcDstTablesRequest) {
	request = &DescribeCustomDataImportSrcDstTablesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeCustomDataImportSrcDstTables", "Drds", "openAPI")
	return
}

// CreateDescribeCustomDataImportSrcDstTablesResponse creates a response to parse from DescribeCustomDataImportSrcDstTables response
func CreateDescribeCustomDataImportSrcDstTablesResponse() (response *DescribeCustomDataImportSrcDstTablesResponse) {
	response = &DescribeCustomDataImportSrcDstTablesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
