package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDataImportTaskReport invokes the drds.DescribeDataImportTaskReport API synchronously
// api document: https://help.aliyun.com/api/drds/describedataimporttaskreport.html
func (client *Client) DescribeDataImportTaskReport(request *DescribeDataImportTaskReportRequest) (response *DescribeDataImportTaskReportResponse, err error) {
	response = CreateDescribeDataImportTaskReportResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDataImportTaskReportWithChan invokes the drds.DescribeDataImportTaskReport API asynchronously
// api document: https://help.aliyun.com/api/drds/describedataimporttaskreport.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDataImportTaskReportWithChan(request *DescribeDataImportTaskReportRequest) (<-chan *DescribeDataImportTaskReportResponse, <-chan error) {
	responseChan := make(chan *DescribeDataImportTaskReportResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDataImportTaskReport(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDataImportTaskReportWithCallback invokes the drds.DescribeDataImportTaskReport API asynchronously
// api document: https://help.aliyun.com/api/drds/describedataimporttaskreport.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDataImportTaskReportWithCallback(request *DescribeDataImportTaskReportRequest, callback func(response *DescribeDataImportTaskReportResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDataImportTaskReportResponse
		var err error
		defer close(result)
		response, err = client.DescribeDataImportTaskReport(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDataImportTaskReportRequest is the request struct for api DescribeDataImportTaskReport
type DescribeDataImportTaskReportRequest struct {
	*requests.RpcRequest
	TaskId requests.Integer `position:"Query" name:"TaskId"`
}

// DescribeDataImportTaskReportResponse is the response struct for api DescribeDataImportTaskReport
type DescribeDataImportTaskReportResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateDescribeDataImportTaskReportRequest creates a request to invoke DescribeDataImportTaskReport API
func CreateDescribeDataImportTaskReportRequest() (request *DescribeDataImportTaskReportRequest) {
	request = &DescribeDataImportTaskReportRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeDataImportTaskReport", "Drds", "openAPI")
	return
}

// CreateDescribeDataImportTaskReportResponse creates a response to parse from DescribeDataImportTaskReport response
func CreateDescribeDataImportTaskReportResponse() (response *DescribeDataImportTaskReportResponse) {
	response = &DescribeDataImportTaskReportResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
