package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeEvaluateDataImportDbTopologys invokes the drds.DescribeEvaluateDataImportDbTopologys API synchronously
// api document: https://help.aliyun.com/api/drds/describeevaluatedataimportdbtopologys.html
func (client *Client) DescribeEvaluateDataImportDbTopologys(request *DescribeEvaluateDataImportDbTopologysRequest) (response *DescribeEvaluateDataImportDbTopologysResponse, err error) {
	response = CreateDescribeEvaluateDataImportDbTopologysResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeEvaluateDataImportDbTopologysWithChan invokes the drds.DescribeEvaluateDataImportDbTopologys API asynchronously
// api document: https://help.aliyun.com/api/drds/describeevaluatedataimportdbtopologys.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeEvaluateDataImportDbTopologysWithChan(request *DescribeEvaluateDataImportDbTopologysRequest) (<-chan *DescribeEvaluateDataImportDbTopologysResponse, <-chan error) {
	responseChan := make(chan *DescribeEvaluateDataImportDbTopologysResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeEvaluateDataImportDbTopologys(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeEvaluateDataImportDbTopologysWithCallback invokes the drds.DescribeEvaluateDataImportDbTopologys API asynchronously
// api document: https://help.aliyun.com/api/drds/describeevaluatedataimportdbtopologys.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeEvaluateDataImportDbTopologysWithCallback(request *DescribeEvaluateDataImportDbTopologysRequest, callback func(response *DescribeEvaluateDataImportDbTopologysResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeEvaluateDataImportDbTopologysResponse
		var err error
		defer close(result)
		response, err = client.DescribeEvaluateDataImportDbTopologys(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeEvaluateDataImportDbTopologysRequest is the request struct for api DescribeEvaluateDataImportDbTopologys
type DescribeEvaluateDataImportDbTopologysRequest struct {
	*requests.RpcRequest
	ImportParam string `position:"Query" name:"ImportParam"`
}

// DescribeEvaluateDataImportDbTopologysResponse is the response struct for api DescribeEvaluateDataImportDbTopologys
type DescribeEvaluateDataImportDbTopologysResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateDescribeEvaluateDataImportDbTopologysRequest creates a request to invoke DescribeEvaluateDataImportDbTopologys API
func CreateDescribeEvaluateDataImportDbTopologysRequest() (request *DescribeEvaluateDataImportDbTopologysRequest) {
	request = &DescribeEvaluateDataImportDbTopologysRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeEvaluateDataImportDbTopologys", "Drds", "openAPI")
	return
}

// CreateDescribeEvaluateDataImportDbTopologysResponse creates a response to parse from DescribeEvaluateDataImportDbTopologys response
func CreateDescribeEvaluateDataImportDbTopologysResponse() (response *DescribeEvaluateDataImportDbTopologysResponse) {
	response = &DescribeEvaluateDataImportDbTopologysResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
