package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeEvaluatePreCheckResult invokes the drds.DescribeEvaluatePreCheckResult API synchronously
// api document: https://help.aliyun.com/api/drds/describeevaluateprecheckresult.html
func (client *Client) DescribeEvaluatePreCheckResult(request *DescribeEvaluatePreCheckResultRequest) (response *DescribeEvaluatePreCheckResultResponse, err error) {
	response = CreateDescribeEvaluatePreCheckResultResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeEvaluatePreCheckResultWithChan invokes the drds.DescribeEvaluatePreCheckResult API asynchronously
// api document: https://help.aliyun.com/api/drds/describeevaluateprecheckresult.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeEvaluatePreCheckResultWithChan(request *DescribeEvaluatePreCheckResultRequest) (<-chan *DescribeEvaluatePreCheckResultResponse, <-chan error) {
	responseChan := make(chan *DescribeEvaluatePreCheckResultResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeEvaluatePreCheckResult(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeEvaluatePreCheckResultWithCallback invokes the drds.DescribeEvaluatePreCheckResult API asynchronously
// api document: https://help.aliyun.com/api/drds/describeevaluateprecheckresult.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeEvaluatePreCheckResultWithCallback(request *DescribeEvaluatePreCheckResultRequest, callback func(response *DescribeEvaluatePreCheckResultResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeEvaluatePreCheckResultResponse
		var err error
		defer close(result)
		response, err = client.DescribeEvaluatePreCheckResult(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeEvaluatePreCheckResultRequest is the request struct for api DescribeEvaluatePreCheckResult
type DescribeEvaluatePreCheckResultRequest struct {
	*requests.RpcRequest
	TaskId requests.Integer `position:"Query" name:"TaskId"`
}

// DescribeEvaluatePreCheckResultResponse is the response struct for api DescribeEvaluatePreCheckResult
type DescribeEvaluatePreCheckResultResponse struct {
	*responses.BaseResponse
	RequestId      string         `json:"RequestId" xml:"RequestId"`
	Success        bool           `json:"Success" xml:"Success"`
	PreCheckResult PreCheckResult `json:"PreCheckResult" xml:"PreCheckResult"`
}

// CreateDescribeEvaluatePreCheckResultRequest creates a request to invoke DescribeEvaluatePreCheckResult API
func CreateDescribeEvaluatePreCheckResultRequest() (request *DescribeEvaluatePreCheckResultRequest) {
	request = &DescribeEvaluatePreCheckResultRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeEvaluatePreCheckResult", "Drds", "openAPI")
	return
}

// CreateDescribeEvaluatePreCheckResultResponse creates a response to parse from DescribeEvaluatePreCheckResult response
func CreateDescribeEvaluatePreCheckResultResponse() (response *DescribeEvaluatePreCheckResultResponse) {
	response = &DescribeEvaluatePreCheckResultResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
