package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRdsDbInfos invokes the drds.DescribeRdsDbInfos API synchronously
// api document: https://help.aliyun.com/api/drds/describerdsdbinfos.html
func (client *Client) DescribeRdsDbInfos(request *DescribeRdsDbInfosRequest) (response *DescribeRdsDbInfosResponse, err error) {
	response = CreateDescribeRdsDbInfosResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRdsDbInfosWithChan invokes the drds.DescribeRdsDbInfos API asynchronously
// api document: https://help.aliyun.com/api/drds/describerdsdbinfos.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRdsDbInfosWithChan(request *DescribeRdsDbInfosRequest) (<-chan *DescribeRdsDbInfosResponse, <-chan error) {
	responseChan := make(chan *DescribeRdsDbInfosResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRdsDbInfos(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRdsDbInfosWithCallback invokes the drds.DescribeRdsDbInfos API asynchronously
// api document: https://help.aliyun.com/api/drds/describerdsdbinfos.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRdsDbInfosWithCallback(request *DescribeRdsDbInfosRequest, callback func(response *DescribeRdsDbInfosResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRdsDbInfosResponse
		var err error
		defer close(result)
		response, err = client.DescribeRdsDbInfos(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRdsDbInfosRequest is the request struct for api DescribeRdsDbInfos
type DescribeRdsDbInfosRequest struct {
	*requests.RpcRequest
	RdsInstId string `position:"Query" name:"RdsInstId"`
	Search    string `position:"Query" name:"Search"`
}

// DescribeRdsDbInfosResponse is the response struct for api DescribeRdsDbInfos
type DescribeRdsDbInfosResponse struct {
	*responses.BaseResponse
	RequestId string                        `json:"RequestId" xml:"RequestId"`
	Success   bool                          `json:"Success" xml:"Success"`
	Total     string                        `json:"Total" xml:"Total"`
	Databases DatabasesInDescribeRdsDbInfos `json:"Databases" xml:"Databases"`
}

// CreateDescribeRdsDbInfosRequest creates a request to invoke DescribeRdsDbInfos API
func CreateDescribeRdsDbInfosRequest() (request *DescribeRdsDbInfosRequest) {
	request = &DescribeRdsDbInfosRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeRdsDbInfos", "Drds", "openAPI")
	return
}

// CreateDescribeRdsDbInfosResponse creates a response to parse from DescribeRdsDbInfos response
func CreateDescribeRdsDbInfosResponse() (response *DescribeRdsDbInfosResponse) {
	response = &DescribeRdsDbInfosResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
