package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRdsInstInfos invokes the drds.DescribeRdsInstInfos API synchronously
// api document: https://help.aliyun.com/api/drds/describerdsinstinfos.html
func (client *Client) DescribeRdsInstInfos(request *DescribeRdsInstInfosRequest) (response *DescribeRdsInstInfosResponse, err error) {
	response = CreateDescribeRdsInstInfosResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRdsInstInfosWithChan invokes the drds.DescribeRdsInstInfos API asynchronously
// api document: https://help.aliyun.com/api/drds/describerdsinstinfos.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRdsInstInfosWithChan(request *DescribeRdsInstInfosRequest) (<-chan *DescribeRdsInstInfosResponse, <-chan error) {
	responseChan := make(chan *DescribeRdsInstInfosResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRdsInstInfos(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRdsInstInfosWithCallback invokes the drds.DescribeRdsInstInfos API asynchronously
// api document: https://help.aliyun.com/api/drds/describerdsinstinfos.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRdsInstInfosWithCallback(request *DescribeRdsInstInfosRequest, callback func(response *DescribeRdsInstInfosResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRdsInstInfosResponse
		var err error
		defer close(result)
		response, err = client.DescribeRdsInstInfos(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRdsInstInfosRequest is the request struct for api DescribeRdsInstInfos
type DescribeRdsInstInfosRequest struct {
	*requests.RpcRequest
	PageNumber requests.Integer `position:"Query" name:"PageNumber"`
	Search     string           `position:"Query" name:"Search"`
	PageSize   requests.Integer `position:"Query" name:"PageSize"`
}

// DescribeRdsInstInfosResponse is the response struct for api DescribeRdsInstInfos
type DescribeRdsInstInfosResponse struct {
	*responses.BaseResponse
	RequestId string                      `json:"RequestId" xml:"RequestId"`
	Items     ItemsInDescribeRdsInstInfos `json:"Items" xml:"Items"`
}

// CreateDescribeRdsInstInfosRequest creates a request to invoke DescribeRdsInstInfos API
func CreateDescribeRdsInstInfosRequest() (request *DescribeRdsInstInfosRequest) {
	request = &DescribeRdsInstInfosRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeRdsInstInfos", "Drds", "openAPI")
	return
}

// CreateDescribeRdsInstInfosResponse creates a response to parse from DescribeRdsInstInfos response
func CreateDescribeRdsInstInfosResponse() (response *DescribeRdsInstInfosResponse) {
	response = &DescribeRdsInstInfosResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
