package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RefreshDrdsAtomUrl invokes the drds.RefreshDrdsAtomUrl API synchronously
// api document: https://help.aliyun.com/api/drds/refreshdrdsatomurl.html
func (client *Client) RefreshDrdsAtomUrl(request *RefreshDrdsAtomUrlRequest) (response *RefreshDrdsAtomUrlResponse, err error) {
	response = CreateRefreshDrdsAtomUrlResponse()
	err = client.DoAction(request, response)
	return
}

// RefreshDrdsAtomUrlWithChan invokes the drds.RefreshDrdsAtomUrl API asynchronously
// api document: https://help.aliyun.com/api/drds/refreshdrdsatomurl.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RefreshDrdsAtomUrlWithChan(request *RefreshDrdsAtomUrlRequest) (<-chan *RefreshDrdsAtomUrlResponse, <-chan error) {
	responseChan := make(chan *RefreshDrdsAtomUrlResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RefreshDrdsAtomUrl(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RefreshDrdsAtomUrlWithCallback invokes the drds.RefreshDrdsAtomUrl API asynchronously
// api document: https://help.aliyun.com/api/drds/refreshdrdsatomurl.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RefreshDrdsAtomUrlWithCallback(request *RefreshDrdsAtomUrlRequest, callback func(response *RefreshDrdsAtomUrlResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RefreshDrdsAtomUrlResponse
		var err error
		defer close(result)
		response, err = client.RefreshDrdsAtomUrl(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RefreshDrdsAtomUrlRequest is the request struct for api RefreshDrdsAtomUrl
type RefreshDrdsAtomUrlRequest struct {
	*requests.RpcRequest
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
	DbName         string `position:"Query" name:"DbName"`
}

// RefreshDrdsAtomUrlResponse is the response struct for api RefreshDrdsAtomUrl
type RefreshDrdsAtomUrlResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Result    bool   `json:"Result" xml:"Result"`
}

// CreateRefreshDrdsAtomUrlRequest creates a request to invoke RefreshDrdsAtomUrl API
func CreateRefreshDrdsAtomUrlRequest() (request *RefreshDrdsAtomUrlRequest) {
	request = &RefreshDrdsAtomUrlRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "RefreshDrdsAtomUrl", "Drds", "openAPI")
	return
}

// CreateRefreshDrdsAtomUrlResponse creates a response to parse from RefreshDrdsAtomUrl response
func CreateRefreshDrdsAtomUrlResponse() (response *RefreshDrdsAtomUrlResponse) {
	response = &RefreshDrdsAtomUrlResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
