package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StartDataImportTask invokes the drds.StartDataImportTask API synchronously
// api document: https://help.aliyun.com/api/drds/startdataimporttask.html
func (client *Client) StartDataImportTask(request *StartDataImportTaskRequest) (response *StartDataImportTaskResponse, err error) {
	response = CreateStartDataImportTaskResponse()
	err = client.DoAction(request, response)
	return
}

// StartDataImportTaskWithChan invokes the drds.StartDataImportTask API asynchronously
// api document: https://help.aliyun.com/api/drds/startdataimporttask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StartDataImportTaskWithChan(request *StartDataImportTaskRequest) (<-chan *StartDataImportTaskResponse, <-chan error) {
	responseChan := make(chan *StartDataImportTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StartDataImportTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StartDataImportTaskWithCallback invokes the drds.StartDataImportTask API asynchronously
// api document: https://help.aliyun.com/api/drds/startdataimporttask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StartDataImportTaskWithCallback(request *StartDataImportTaskRequest, callback func(response *StartDataImportTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StartDataImportTaskResponse
		var err error
		defer close(result)
		response, err = client.StartDataImportTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StartDataImportTaskRequest is the request struct for api StartDataImportTask
type StartDataImportTaskRequest struct {
	*requests.RpcRequest
	TaskId requests.Integer `position:"Query" name:"TaskId"`
}

// StartDataImportTaskResponse is the response struct for api StartDataImportTask
type StartDataImportTaskResponse struct {
	*responses.BaseResponse
	RequestId        string           `json:"RequestId" xml:"RequestId"`
	Success          bool             `json:"Success" xml:"Success"`
	TaskManageResult TaskManageResult `json:"TaskManageResult" xml:"TaskManageResult"`
}

// CreateStartDataImportTaskRequest creates a request to invoke StartDataImportTask API
func CreateStartDataImportTaskRequest() (request *StartDataImportTaskRequest) {
	request = &StartDataImportTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "StartDataImportTask", "Drds", "openAPI")
	return
}

// CreateStartDataImportTaskResponse creates a response to parse from StartDataImportTask response
func CreateStartDataImportTaskResponse() (response *StartDataImportTaskResponse) {
	response = &StartDataImportTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
