package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StopDataImportTask invokes the drds.StopDataImportTask API synchronously
// api document: https://help.aliyun.com/api/drds/stopdataimporttask.html
func (client *Client) StopDataImportTask(request *StopDataImportTaskRequest) (response *StopDataImportTaskResponse, err error) {
	response = CreateStopDataImportTaskResponse()
	err = client.DoAction(request, response)
	return
}

// StopDataImportTaskWithChan invokes the drds.StopDataImportTask API asynchronously
// api document: https://help.aliyun.com/api/drds/stopdataimporttask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StopDataImportTaskWithChan(request *StopDataImportTaskRequest) (<-chan *StopDataImportTaskResponse, <-chan error) {
	responseChan := make(chan *StopDataImportTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StopDataImportTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StopDataImportTaskWithCallback invokes the drds.StopDataImportTask API asynchronously
// api document: https://help.aliyun.com/api/drds/stopdataimporttask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StopDataImportTaskWithCallback(request *StopDataImportTaskRequest, callback func(response *StopDataImportTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StopDataImportTaskResponse
		var err error
		defer close(result)
		response, err = client.StopDataImportTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StopDataImportTaskRequest is the request struct for api StopDataImportTask
type StopDataImportTaskRequest struct {
	*requests.RpcRequest
	TaskId requests.Integer `position:"Query" name:"TaskId"`
}

// StopDataImportTaskResponse is the response struct for api StopDataImportTask
type StopDataImportTaskResponse struct {
	*responses.BaseResponse
	RequestId        string           `json:"RequestId" xml:"RequestId"`
	Success          bool             `json:"Success" xml:"Success"`
	TaskManageResult TaskManageResult `json:"TaskManageResult" xml:"TaskManageResult"`
}

// CreateStopDataImportTaskRequest creates a request to invoke StopDataImportTask API
func CreateStopDataImportTaskRequest() (request *StopDataImportTaskRequest) {
	request = &StopDataImportTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "StopDataImportTask", "Drds", "openAPI")
	return
}

// CreateStopDataImportTaskResponse creates a response to parse from StopDataImportTask response
func CreateStopDataImportTaskResponse() (response *StopDataImportTaskResponse) {
	response = &StopDataImportTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
