package ecs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateAutoProvisioningGroup invokes the ecs.CreateAutoProvisioningGroup API synchronously
// api document: https://help.aliyun.com/api/ecs/createautoprovisioninggroup.html
func (client *Client) CreateAutoProvisioningGroup(request *CreateAutoProvisioningGroupRequest) (response *CreateAutoProvisioningGroupResponse, err error) {
	response = CreateCreateAutoProvisioningGroupResponse()
	err = client.DoAction(request, response)
	return
}

// CreateAutoProvisioningGroupWithChan invokes the ecs.CreateAutoProvisioningGroup API asynchronously
// api document: https://help.aliyun.com/api/ecs/createautoprovisioninggroup.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateAutoProvisioningGroupWithChan(request *CreateAutoProvisioningGroupRequest) (<-chan *CreateAutoProvisioningGroupResponse, <-chan error) {
	responseChan := make(chan *CreateAutoProvisioningGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateAutoProvisioningGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateAutoProvisioningGroupWithCallback invokes the ecs.CreateAutoProvisioningGroup API asynchronously
// api document: https://help.aliyun.com/api/ecs/createautoprovisioninggroup.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateAutoProvisioningGroupWithCallback(request *CreateAutoProvisioningGroupRequest, callback func(response *CreateAutoProvisioningGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateAutoProvisioningGroupResponse
		var err error
		defer close(result)
		response, err = client.CreateAutoProvisioningGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateAutoProvisioningGroupRequest is the request struct for api CreateAutoProvisioningGroup
type CreateAutoProvisioningGroupRequest struct {
	*requests.RpcRequest
	ResourceOwnerId                  requests.Integer                                   `position:"Query" name:"ResourceOwnerId"`
	AutoProvisioningGroupType        string                                             `position:"Query" name:"AutoProvisioningGroupType"`
	Description                      string                                             `position:"Query" name:"Description"`
	TerminateInstancesWithExpiration requests.Boolean                                   `position:"Query" name:"TerminateInstancesWithExpiration"`
	ResourceGroupId                  string                                             `position:"Query" name:"ResourceGroupId"`
	SpotAllocationStrategy           string                                             `position:"Query" name:"SpotAllocationStrategy"`
	TerminateInstances               requests.Boolean                                   `position:"Query" name:"TerminateInstances"`
	PayAsYouGoAllocationStrategy     string                                             `position:"Query" name:"PayAsYouGoAllocationStrategy"`
	DefaultTargetCapacityType        string                                             `position:"Query" name:"DefaultTargetCapacityType"`
	ExcessCapacityTerminationPolicy  string                                             `position:"Query" name:"ExcessCapacityTerminationPolicy"`
	LaunchTemplateConfig             *[]CreateAutoProvisioningGroupLaunchTemplateConfig `position:"Query" name:"LaunchTemplateConfig"  type:"Repeated"`
	ValidUntil                       string                                             `position:"Query" name:"ValidUntil"`
	SpotInstanceInterruptionBehavior string                                             `position:"Query" name:"SpotInstanceInterruptionBehavior"`
	LaunchTemplateId                 string                                             `position:"Query" name:"LaunchTemplateId"`
	ResourceOwnerAccount             string                                             `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount                     string                                             `position:"Query" name:"OwnerAccount"`
	SpotInstancePoolsToUseCount      requests.Integer                                   `position:"Query" name:"SpotInstancePoolsToUseCount"`
	OwnerId                          requests.Integer                                   `position:"Query" name:"OwnerId"`
	LaunchTemplateVersion            string                                             `position:"Query" name:"LaunchTemplateVersion"`
	PayAsYouGoTargetCapacity         string                                             `position:"Query" name:"PayAsYouGoTargetCapacity"`
	TotalTargetCapacity              string                                             `position:"Query" name:"TotalTargetCapacity"`
	SpotTargetCapacity               string                                             `position:"Query" name:"SpotTargetCapacity"`
	ValidFrom                        string                                             `position:"Query" name:"ValidFrom"`
	AutoProvisioningGroupName        string                                             `position:"Query" name:"AutoProvisioningGroupName"`
	MaxSpotPrice                     requests.Float                                     `position:"Query" name:"MaxSpotPrice"`
}

// CreateAutoProvisioningGroupLaunchTemplateConfig is a repeated param struct in CreateAutoProvisioningGroupRequest
type CreateAutoProvisioningGroupLaunchTemplateConfig struct {
	InstanceType     string `name:"InstanceType"`
	MaxPrice         string `name:"MaxPrice"`
	VSwitchId        string `name:"VSwitchId"`
	WeightedCapacity string `name:"WeightedCapacity"`
	Priority         string `name:"Priority"`
}

// CreateAutoProvisioningGroupResponse is the response struct for api CreateAutoProvisioningGroup
type CreateAutoProvisioningGroupResponse struct {
	*responses.BaseResponse
	RequestId               string `json:"RequestId" xml:"RequestId"`
	AutoProvisioningGroupId string `json:"AutoProvisioningGroupId" xml:"AutoProvisioningGroupId"`
}

// CreateCreateAutoProvisioningGroupRequest creates a request to invoke CreateAutoProvisioningGroup API
func CreateCreateAutoProvisioningGroupRequest() (request *CreateAutoProvisioningGroupRequest) {
	request = &CreateAutoProvisioningGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ecs", "2014-05-26", "CreateAutoProvisioningGroup", "ecs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateAutoProvisioningGroupResponse creates a response to parse from CreateAutoProvisioningGroup response
func CreateCreateAutoProvisioningGroupResponse() (response *CreateAutoProvisioningGroupResponse) {
	response = &CreateAutoProvisioningGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
