package ehpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListAccountMapping invokes the ehpc.ListAccountMapping API synchronously
// api document: https://help.aliyun.com/api/ehpc/listaccountmapping.html
func (client *Client) ListAccountMapping(request *ListAccountMappingRequest) (response *ListAccountMappingResponse, err error) {
	response = CreateListAccountMappingResponse()
	err = client.DoAction(request, response)
	return
}

// ListAccountMappingWithChan invokes the ehpc.ListAccountMapping API asynchronously
// api document: https://help.aliyun.com/api/ehpc/listaccountmapping.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListAccountMappingWithChan(request *ListAccountMappingRequest) (<-chan *ListAccountMappingResponse, <-chan error) {
	responseChan := make(chan *ListAccountMappingResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListAccountMapping(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListAccountMappingWithCallback invokes the ehpc.ListAccountMapping API asynchronously
// api document: https://help.aliyun.com/api/ehpc/listaccountmapping.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListAccountMappingWithCallback(request *ListAccountMappingRequest, callback func(response *ListAccountMappingResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListAccountMappingResponse
		var err error
		defer close(result)
		response, err = client.ListAccountMapping(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListAccountMappingRequest is the request struct for api ListAccountMapping
type ListAccountMappingRequest struct {
	*requests.RpcRequest
	ClusterId string `position:"Query" name:"ClusterId"`
}

// ListAccountMappingResponse is the response struct for api ListAccountMapping
type ListAccountMappingResponse struct {
	*responses.BaseResponse
	RequestId    string       `json:"RequestId" xml:"RequestId"`
	UserMappings UserMappings `json:"UserMappings" xml:"UserMappings"`
}

// CreateListAccountMappingRequest creates a request to invoke ListAccountMapping API
func CreateListAccountMappingRequest() (request *ListAccountMappingRequest) {
	request = &ListAccountMappingRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("EHPC", "2018-04-12", "ListAccountMapping", "", "")
	request.Method = requests.GET
	return
}

// CreateListAccountMappingResponse creates a response to parse from ListAccountMapping response
func CreateListAccountMappingResponse() (response *ListAccountMappingResponse) {
	response = &ListAccountMappingResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
