package ehpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UnbindAccountToClusterUser invokes the ehpc.UnbindAccountToClusterUser API synchronously
// api document: https://help.aliyun.com/api/ehpc/unbindaccounttoclusteruser.html
func (client *Client) UnbindAccountToClusterUser(request *UnbindAccountToClusterUserRequest) (response *UnbindAccountToClusterUserResponse, err error) {
	response = CreateUnbindAccountToClusterUserResponse()
	err = client.DoAction(request, response)
	return
}

// UnbindAccountToClusterUserWithChan invokes the ehpc.UnbindAccountToClusterUser API asynchronously
// api document: https://help.aliyun.com/api/ehpc/unbindaccounttoclusteruser.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UnbindAccountToClusterUserWithChan(request *UnbindAccountToClusterUserRequest) (<-chan *UnbindAccountToClusterUserResponse, <-chan error) {
	responseChan := make(chan *UnbindAccountToClusterUserResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UnbindAccountToClusterUser(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UnbindAccountToClusterUserWithCallback invokes the ehpc.UnbindAccountToClusterUser API asynchronously
// api document: https://help.aliyun.com/api/ehpc/unbindaccounttoclusteruser.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UnbindAccountToClusterUserWithCallback(request *UnbindAccountToClusterUserRequest, callback func(response *UnbindAccountToClusterUserResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UnbindAccountToClusterUserResponse
		var err error
		defer close(result)
		response, err = client.UnbindAccountToClusterUser(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UnbindAccountToClusterUserRequest is the request struct for api UnbindAccountToClusterUser
type UnbindAccountToClusterUserRequest struct {
	*requests.RpcRequest
	ClusterId  string `position:"Query" name:"ClusterId"`
	AccountUid string `position:"Query" name:"AccountUid"`
	UserName   string `position:"Query" name:"UserName"`
}

// UnbindAccountToClusterUserResponse is the response struct for api UnbindAccountToClusterUser
type UnbindAccountToClusterUserResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUnbindAccountToClusterUserRequest creates a request to invoke UnbindAccountToClusterUser API
func CreateUnbindAccountToClusterUserRequest() (request *UnbindAccountToClusterUserRequest) {
	request = &UnbindAccountToClusterUserRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("EHPC", "2018-04-12", "UnbindAccountToClusterUser", "", "")
	request.Method = requests.GET
	return
}

// CreateUnbindAccountToClusterUserResponse creates a response to parse from UnbindAccountToClusterUser response
func CreateUnbindAccountToClusterUserResponse() (response *UnbindAccountToClusterUserResponse) {
	response = &UnbindAccountToClusterUserResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
