package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CleanupFlowEntitySnapshot invokes the emr.CleanupFlowEntitySnapshot API synchronously
// api document: https://help.aliyun.com/api/emr/cleanupflowentitysnapshot.html
func (client *Client) CleanupFlowEntitySnapshot(request *CleanupFlowEntitySnapshotRequest) (response *CleanupFlowEntitySnapshotResponse, err error) {
	response = CreateCleanupFlowEntitySnapshotResponse()
	err = client.DoAction(request, response)
	return
}

// CleanupFlowEntitySnapshotWithChan invokes the emr.CleanupFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/cleanupflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CleanupFlowEntitySnapshotWithChan(request *CleanupFlowEntitySnapshotRequest) (<-chan *CleanupFlowEntitySnapshotResponse, <-chan error) {
	responseChan := make(chan *CleanupFlowEntitySnapshotResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CleanupFlowEntitySnapshot(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CleanupFlowEntitySnapshotWithCallback invokes the emr.CleanupFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/cleanupflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CleanupFlowEntitySnapshotWithCallback(request *CleanupFlowEntitySnapshotRequest, callback func(response *CleanupFlowEntitySnapshotResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CleanupFlowEntitySnapshotResponse
		var err error
		defer close(result)
		response, err = client.CleanupFlowEntitySnapshot(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CleanupFlowEntitySnapshotRequest is the request struct for api CleanupFlowEntitySnapshot
type CleanupFlowEntitySnapshotRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	EntityIdList    string           `position:"Query" name:"EntityIdList"`
}

// CleanupFlowEntitySnapshotResponse is the response struct for api CleanupFlowEntitySnapshot
type CleanupFlowEntitySnapshotResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      bool   `json:"Data" xml:"Data"`
}

// CreateCleanupFlowEntitySnapshotRequest creates a request to invoke CleanupFlowEntitySnapshot API
func CreateCleanupFlowEntitySnapshotRequest() (request *CleanupFlowEntitySnapshotRequest) {
	request = &CleanupFlowEntitySnapshotRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "CleanupFlowEntitySnapshot", "emr", "openAPI")
	return
}

// CreateCleanupFlowEntitySnapshotResponse creates a response to parse from CleanupFlowEntitySnapshot response
func CreateCleanupFlowEntitySnapshotResponse() (response *CleanupFlowEntitySnapshotResponse) {
	response = &CleanupFlowEntitySnapshotResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
