package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CommitFlowEntitySnapshot invokes the emr.CommitFlowEntitySnapshot API synchronously
// api document: https://help.aliyun.com/api/emr/commitflowentitysnapshot.html
func (client *Client) CommitFlowEntitySnapshot(request *CommitFlowEntitySnapshotRequest) (response *CommitFlowEntitySnapshotResponse, err error) {
	response = CreateCommitFlowEntitySnapshotResponse()
	err = client.DoAction(request, response)
	return
}

// CommitFlowEntitySnapshotWithChan invokes the emr.CommitFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/commitflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CommitFlowEntitySnapshotWithChan(request *CommitFlowEntitySnapshotRequest) (<-chan *CommitFlowEntitySnapshotResponse, <-chan error) {
	responseChan := make(chan *CommitFlowEntitySnapshotResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CommitFlowEntitySnapshot(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CommitFlowEntitySnapshotWithCallback invokes the emr.CommitFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/commitflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CommitFlowEntitySnapshotWithCallback(request *CommitFlowEntitySnapshotRequest, callback func(response *CommitFlowEntitySnapshotResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CommitFlowEntitySnapshotResponse
		var err error
		defer close(result)
		response, err = client.CommitFlowEntitySnapshot(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CommitFlowEntitySnapshotRequest is the request struct for api CommitFlowEntitySnapshot
type CommitFlowEntitySnapshotRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	EntityType      string           `position:"Query" name:"EntityType"`
	EntityId        string           `position:"Query" name:"EntityId"`
	Message         string           `position:"Query" name:"Message"`
}

// CommitFlowEntitySnapshotResponse is the response struct for api CommitFlowEntitySnapshot
type CommitFlowEntitySnapshotResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateCommitFlowEntitySnapshotRequest creates a request to invoke CommitFlowEntitySnapshot API
func CreateCommitFlowEntitySnapshotRequest() (request *CommitFlowEntitySnapshotRequest) {
	request = &CommitFlowEntitySnapshotRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "CommitFlowEntitySnapshot", "emr", "openAPI")
	return
}

// CreateCommitFlowEntitySnapshotResponse creates a response to parse from CommitFlowEntitySnapshot response
func CreateCommitFlowEntitySnapshotResponse() (response *CommitFlowEntitySnapshotResponse) {
	response = &CommitFlowEntitySnapshotResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
