package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeFlowEntitySnapshot invokes the emr.DescribeFlowEntitySnapshot API synchronously
// api document: https://help.aliyun.com/api/emr/describeflowentitysnapshot.html
func (client *Client) DescribeFlowEntitySnapshot(request *DescribeFlowEntitySnapshotRequest) (response *DescribeFlowEntitySnapshotResponse, err error) {
	response = CreateDescribeFlowEntitySnapshotResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeFlowEntitySnapshotWithChan invokes the emr.DescribeFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/describeflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeFlowEntitySnapshotWithChan(request *DescribeFlowEntitySnapshotRequest) (<-chan *DescribeFlowEntitySnapshotResponse, <-chan error) {
	responseChan := make(chan *DescribeFlowEntitySnapshotResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeFlowEntitySnapshot(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeFlowEntitySnapshotWithCallback invokes the emr.DescribeFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/describeflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeFlowEntitySnapshotWithCallback(request *DescribeFlowEntitySnapshotRequest, callback func(response *DescribeFlowEntitySnapshotResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeFlowEntitySnapshotResponse
		var err error
		defer close(result)
		response, err = client.DescribeFlowEntitySnapshot(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeFlowEntitySnapshotRequest is the request struct for api DescribeFlowEntitySnapshot
type DescribeFlowEntitySnapshotRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageCount       requests.Integer `position:"Query" name:"PageCount"`
	OrderMode       string           `position:"Query" name:"OrderMode"`
	EntityId        string           `position:"Query" name:"EntityId"`
	PageNumber      requests.Integer `position:"Query" name:"PageNumber"`
	Limit           requests.Integer `position:"Query" name:"Limit"`
	PageSize        requests.Integer `position:"Query" name:"PageSize"`
	CommitterId     string           `position:"Query" name:"CommitterId"`
	CurrentSize     requests.Integer `position:"Query" name:"CurrentSize"`
	OrderField      string           `position:"Query" name:"OrderField"`
	EntityGroupId   string           `position:"Query" name:"EntityGroupId"`
	Revision        string           `position:"Query" name:"Revision"`
	EntityType      string           `position:"Query" name:"EntityType"`
}

// DescribeFlowEntitySnapshotResponse is the response struct for api DescribeFlowEntitySnapshot
type DescribeFlowEntitySnapshotResponse struct {
	*responses.BaseResponse
	RequestId     string `json:"RequestId" xml:"RequestId"`
	GmtCreate     int64  `json:"GmtCreate" xml:"GmtCreate"`
	Revision      string `json:"Revision" xml:"Revision"`
	UserId        string `json:"UserId" xml:"UserId"`
	CommitterId   string `json:"CommitterId" xml:"CommitterId"`
	Message       string `json:"Message" xml:"Message"`
	EntityId      string `json:"EntityId" xml:"EntityId"`
	EntityGroupId string `json:"EntityGroupId" xml:"EntityGroupId"`
	EntityType    string `json:"EntityType" xml:"EntityType"`
	Data          string `json:"Data" xml:"Data"`
	Active        bool   `json:"Active" xml:"Active"`
}

// CreateDescribeFlowEntitySnapshotRequest creates a request to invoke DescribeFlowEntitySnapshot API
func CreateDescribeFlowEntitySnapshotRequest() (request *DescribeFlowEntitySnapshotRequest) {
	request = &DescribeFlowEntitySnapshotRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "DescribeFlowEntitySnapshot", "emr", "openAPI")
	return
}

// CreateDescribeFlowEntitySnapshotResponse creates a response to parse from DescribeFlowEntitySnapshot response
func CreateDescribeFlowEntitySnapshotResponse() (response *DescribeFlowEntitySnapshotResponse) {
	response = &DescribeFlowEntitySnapshotResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
