package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DiffFlowEntitySnapshot invokes the emr.DiffFlowEntitySnapshot API synchronously
// api document: https://help.aliyun.com/api/emr/diffflowentitysnapshot.html
func (client *Client) DiffFlowEntitySnapshot(request *DiffFlowEntitySnapshotRequest) (response *DiffFlowEntitySnapshotResponse, err error) {
	response = CreateDiffFlowEntitySnapshotResponse()
	err = client.DoAction(request, response)
	return
}

// DiffFlowEntitySnapshotWithChan invokes the emr.DiffFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/diffflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DiffFlowEntitySnapshotWithChan(request *DiffFlowEntitySnapshotRequest) (<-chan *DiffFlowEntitySnapshotResponse, <-chan error) {
	responseChan := make(chan *DiffFlowEntitySnapshotResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DiffFlowEntitySnapshot(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DiffFlowEntitySnapshotWithCallback invokes the emr.DiffFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/diffflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DiffFlowEntitySnapshotWithCallback(request *DiffFlowEntitySnapshotRequest, callback func(response *DiffFlowEntitySnapshotResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DiffFlowEntitySnapshotResponse
		var err error
		defer close(result)
		response, err = client.DiffFlowEntitySnapshot(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DiffFlowEntitySnapshotRequest is the request struct for api DiffFlowEntitySnapshot
type DiffFlowEntitySnapshotRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SrcRevision     string           `position:"Query" name:"SrcRevision"`
	EntityId        string           `position:"Query" name:"EntityId"`
	DstRevision     string           `position:"Query" name:"DstRevision"`
	EntityType      string           `position:"Query" name:"EntityType"`
}

// DiffFlowEntitySnapshotResponse is the response struct for api DiffFlowEntitySnapshot
type DiffFlowEntitySnapshotResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateDiffFlowEntitySnapshotRequest creates a request to invoke DiffFlowEntitySnapshot API
func CreateDiffFlowEntitySnapshotRequest() (request *DiffFlowEntitySnapshotRequest) {
	request = &DiffFlowEntitySnapshotRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "DiffFlowEntitySnapshot", "emr", "openAPI")
	return
}

// CreateDiffFlowEntitySnapshotResponse creates a response to parse from DiffFlowEntitySnapshot response
func CreateDiffFlowEntitySnapshotResponse() (response *DiffFlowEntitySnapshotResponse) {
	response = &DiffFlowEntitySnapshotResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
