package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListFlowEntitySnapshot invokes the emr.ListFlowEntitySnapshot API synchronously
// api document: https://help.aliyun.com/api/emr/listflowentitysnapshot.html
func (client *Client) ListFlowEntitySnapshot(request *ListFlowEntitySnapshotRequest) (response *ListFlowEntitySnapshotResponse, err error) {
	response = CreateListFlowEntitySnapshotResponse()
	err = client.DoAction(request, response)
	return
}

// ListFlowEntitySnapshotWithChan invokes the emr.ListFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/listflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListFlowEntitySnapshotWithChan(request *ListFlowEntitySnapshotRequest) (<-chan *ListFlowEntitySnapshotResponse, <-chan error) {
	responseChan := make(chan *ListFlowEntitySnapshotResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListFlowEntitySnapshot(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListFlowEntitySnapshotWithCallback invokes the emr.ListFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/listflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListFlowEntitySnapshotWithCallback(request *ListFlowEntitySnapshotRequest, callback func(response *ListFlowEntitySnapshotResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListFlowEntitySnapshotResponse
		var err error
		defer close(result)
		response, err = client.ListFlowEntitySnapshot(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListFlowEntitySnapshotRequest is the request struct for api ListFlowEntitySnapshot
type ListFlowEntitySnapshotRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageCount       requests.Integer `position:"Query" name:"PageCount"`
	OrderMode       string           `position:"Query" name:"OrderMode"`
	EntityId        string           `position:"Query" name:"EntityId"`
	PageNumber      requests.Integer `position:"Query" name:"PageNumber"`
	Limit           requests.Integer `position:"Query" name:"Limit"`
	PageSize        requests.Integer `position:"Query" name:"PageSize"`
	CommitterId     string           `position:"Query" name:"CommitterId"`
	CurrentSize     requests.Integer `position:"Query" name:"CurrentSize"`
	OrderField      string           `position:"Query" name:"OrderField"`
	EntityGroupId   string           `position:"Query" name:"EntityGroupId"`
	Revision        string           `position:"Query" name:"Revision"`
	EntityType      string           `position:"Query" name:"EntityType"`
}

// ListFlowEntitySnapshotResponse is the response struct for api ListFlowEntitySnapshot
type ListFlowEntitySnapshotResponse struct {
	*responses.BaseResponse
	RequestId  string                        `json:"RequestId" xml:"RequestId"`
	PageNumber int                           `json:"PageNumber" xml:"PageNumber"`
	PageSize   int                           `json:"PageSize" xml:"PageSize"`
	TotalCount int                           `json:"TotalCount" xml:"TotalCount"`
	Items      ItemsInListFlowEntitySnapshot `json:"Items" xml:"Items"`
}

// CreateListFlowEntitySnapshotRequest creates a request to invoke ListFlowEntitySnapshot API
func CreateListFlowEntitySnapshotRequest() (request *ListFlowEntitySnapshotRequest) {
	request = &ListFlowEntitySnapshotRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "ListFlowEntitySnapshot", "emr", "openAPI")
	return
}

// CreateListFlowEntitySnapshotResponse creates a response to parse from ListFlowEntitySnapshot response
func CreateListFlowEntitySnapshotResponse() (response *ListFlowEntitySnapshotResponse) {
	response = &ListFlowEntitySnapshotResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
