package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryTableData invokes the emr.QueryTableData API synchronously
// api document: https://help.aliyun.com/api/emr/querytabledata.html
func (client *Client) QueryTableData(request *QueryTableDataRequest) (response *QueryTableDataResponse, err error) {
	response = CreateQueryTableDataResponse()
	err = client.DoAction(request, response)
	return
}

// QueryTableDataWithChan invokes the emr.QueryTableData API asynchronously
// api document: https://help.aliyun.com/api/emr/querytabledata.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryTableDataWithChan(request *QueryTableDataRequest) (<-chan *QueryTableDataResponse, <-chan error) {
	responseChan := make(chan *QueryTableDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryTableData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryTableDataWithCallback invokes the emr.QueryTableData API asynchronously
// api document: https://help.aliyun.com/api/emr/querytabledata.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryTableDataWithCallback(request *QueryTableDataRequest, callback func(response *QueryTableDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryTableDataResponse
		var err error
		defer close(result)
		response, err = client.QueryTableData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryTableDataRequest is the request struct for api QueryTableData
type QueryTableDataRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	Payload         string           `position:"Query" name:"Payload"`
}

// QueryTableDataResponse is the response struct for api QueryTableData
type QueryTableDataResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateQueryTableDataRequest creates a request to invoke QueryTableData API
func CreateQueryTableDataRequest() (request *QueryTableDataRequest) {
	request = &QueryTableDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "QueryTableData", "emr", "openAPI")
	return
}

// CreateQueryTableDataResponse creates a response to parse from QueryTableData response
func CreateQueryTableDataResponse() (response *QueryTableDataResponse) {
	response = &QueryTableDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
