package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryTrendData invokes the emr.QueryTrendData API synchronously
// api document: https://help.aliyun.com/api/emr/querytrenddata.html
func (client *Client) QueryTrendData(request *QueryTrendDataRequest) (response *QueryTrendDataResponse, err error) {
	response = CreateQueryTrendDataResponse()
	err = client.DoAction(request, response)
	return
}

// QueryTrendDataWithChan invokes the emr.QueryTrendData API asynchronously
// api document: https://help.aliyun.com/api/emr/querytrenddata.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryTrendDataWithChan(request *QueryTrendDataRequest) (<-chan *QueryTrendDataResponse, <-chan error) {
	responseChan := make(chan *QueryTrendDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryTrendData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryTrendDataWithCallback invokes the emr.QueryTrendData API asynchronously
// api document: https://help.aliyun.com/api/emr/querytrenddata.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryTrendDataWithCallback(request *QueryTrendDataRequest, callback func(response *QueryTrendDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryTrendDataResponse
		var err error
		defer close(result)
		response, err = client.QueryTrendData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryTrendDataRequest is the request struct for api QueryTrendData
type QueryTrendDataRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	Payload         string           `position:"Query" name:"Payload"`
}

// QueryTrendDataResponse is the response struct for api QueryTrendData
type QueryTrendDataResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateQueryTrendDataRequest creates a request to invoke QueryTrendData API
func CreateQueryTrendDataRequest() (request *QueryTrendDataRequest) {
	request = &QueryTrendDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "QueryTrendData", "emr", "openAPI")
	return
}

// CreateQueryTrendDataResponse creates a response to parse from QueryTrendData response
func CreateQueryTrendDataResponse() (response *QueryTrendDataResponse) {
	response = &QueryTrendDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
