package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RestoreFlowEntitySnapshot invokes the emr.RestoreFlowEntitySnapshot API synchronously
// api document: https://help.aliyun.com/api/emr/restoreflowentitysnapshot.html
func (client *Client) RestoreFlowEntitySnapshot(request *RestoreFlowEntitySnapshotRequest) (response *RestoreFlowEntitySnapshotResponse, err error) {
	response = CreateRestoreFlowEntitySnapshotResponse()
	err = client.DoAction(request, response)
	return
}

// RestoreFlowEntitySnapshotWithChan invokes the emr.RestoreFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/restoreflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RestoreFlowEntitySnapshotWithChan(request *RestoreFlowEntitySnapshotRequest) (<-chan *RestoreFlowEntitySnapshotResponse, <-chan error) {
	responseChan := make(chan *RestoreFlowEntitySnapshotResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RestoreFlowEntitySnapshot(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RestoreFlowEntitySnapshotWithCallback invokes the emr.RestoreFlowEntitySnapshot API asynchronously
// api document: https://help.aliyun.com/api/emr/restoreflowentitysnapshot.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RestoreFlowEntitySnapshotWithCallback(request *RestoreFlowEntitySnapshotRequest, callback func(response *RestoreFlowEntitySnapshotResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RestoreFlowEntitySnapshotResponse
		var err error
		defer close(result)
		response, err = client.RestoreFlowEntitySnapshot(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RestoreFlowEntitySnapshotRequest is the request struct for api RestoreFlowEntitySnapshot
type RestoreFlowEntitySnapshotRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	EntityId        string           `position:"Query" name:"EntityId"`
	Revision        string           `position:"Query" name:"Revision"`
	EntityType      string           `position:"Query" name:"EntityType"`
	OperatorId      string           `position:"Query" name:"OperatorId"`
}

// RestoreFlowEntitySnapshotResponse is the response struct for api RestoreFlowEntitySnapshot
type RestoreFlowEntitySnapshotResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      bool   `json:"Data" xml:"Data"`
}

// CreateRestoreFlowEntitySnapshotRequest creates a request to invoke RestoreFlowEntitySnapshot API
func CreateRestoreFlowEntitySnapshotRequest() (request *RestoreFlowEntitySnapshotRequest) {
	request = &RestoreFlowEntitySnapshotRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "RestoreFlowEntitySnapshot", "emr", "openAPI")
	return
}

// CreateRestoreFlowEntitySnapshotResponse creates a response to parse from RestoreFlowEntitySnapshot response
func CreateRestoreFlowEntitySnapshotResponse() (response *RestoreFlowEntitySnapshotResponse) {
	response = &RestoreFlowEntitySnapshotResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
