package green

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteKeywordLib invokes the green.DeleteKeywordLib API synchronously
// api document: https://help.aliyun.com/api/green/deletekeywordlib.html
func (client *Client) DeleteKeywordLib(request *DeleteKeywordLibRequest) (response *DeleteKeywordLibResponse, err error) {
	response = CreateDeleteKeywordLibResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteKeywordLibWithChan invokes the green.DeleteKeywordLib API asynchronously
// api document: https://help.aliyun.com/api/green/deletekeywordlib.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteKeywordLibWithChan(request *DeleteKeywordLibRequest) (<-chan *DeleteKeywordLibResponse, <-chan error) {
	responseChan := make(chan *DeleteKeywordLibResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteKeywordLib(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteKeywordLibWithCallback invokes the green.DeleteKeywordLib API asynchronously
// api document: https://help.aliyun.com/api/green/deletekeywordlib.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteKeywordLibWithCallback(request *DeleteKeywordLibRequest, callback func(response *DeleteKeywordLibResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteKeywordLibResponse
		var err error
		defer close(result)
		response, err = client.DeleteKeywordLib(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteKeywordLibRequest is the request struct for api DeleteKeywordLib
type DeleteKeywordLibRequest struct {
	*requests.RpcRequest
	SourceIp string           `position:"Query" name:"SourceIp"`
	Id       requests.Integer `position:"Query" name:"Id"`
	Lang     string           `position:"Query" name:"Lang"`
}

// DeleteKeywordLibResponse is the response struct for api DeleteKeywordLib
type DeleteKeywordLibResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteKeywordLibRequest creates a request to invoke DeleteKeywordLib API
func CreateDeleteKeywordLibRequest() (request *DeleteKeywordLibRequest) {
	request = &DeleteKeywordLibRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Green", "2017-08-23", "DeleteKeywordLib", "green", "openAPI")
	return
}

// CreateDeleteKeywordLibResponse creates a response to parse from DeleteKeywordLib response
func CreateDeleteKeywordLibResponse() (response *DeleteKeywordLibResponse) {
	response = &DeleteKeywordLibResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
