package imm

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StopStreamAnalyseTask invokes the imm.StopStreamAnalyseTask API synchronously
// api document: https://help.aliyun.com/api/imm/stopstreamanalysetask.html
func (client *Client) StopStreamAnalyseTask(request *StopStreamAnalyseTaskRequest) (response *StopStreamAnalyseTaskResponse, err error) {
	response = CreateStopStreamAnalyseTaskResponse()
	err = client.DoAction(request, response)
	return
}

// StopStreamAnalyseTaskWithChan invokes the imm.StopStreamAnalyseTask API asynchronously
// api document: https://help.aliyun.com/api/imm/stopstreamanalysetask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StopStreamAnalyseTaskWithChan(request *StopStreamAnalyseTaskRequest) (<-chan *StopStreamAnalyseTaskResponse, <-chan error) {
	responseChan := make(chan *StopStreamAnalyseTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StopStreamAnalyseTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StopStreamAnalyseTaskWithCallback invokes the imm.StopStreamAnalyseTask API asynchronously
// api document: https://help.aliyun.com/api/imm/stopstreamanalysetask.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) StopStreamAnalyseTaskWithCallback(request *StopStreamAnalyseTaskRequest, callback func(response *StopStreamAnalyseTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StopStreamAnalyseTaskResponse
		var err error
		defer close(result)
		response, err = client.StopStreamAnalyseTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StopStreamAnalyseTaskRequest is the request struct for api StopStreamAnalyseTask
type StopStreamAnalyseTaskRequest struct {
	*requests.RpcRequest
	Project string `position:"Query" name:"Project"`
	TaskId  string `position:"Query" name:"TaskId"`
}

// StopStreamAnalyseTaskResponse is the response struct for api StopStreamAnalyseTask
type StopStreamAnalyseTaskResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	TaskId    string `json:"TaskId" xml:"TaskId"`
}

// CreateStopStreamAnalyseTaskRequest creates a request to invoke StopStreamAnalyseTask API
func CreateStopStreamAnalyseTaskRequest() (request *StopStreamAnalyseTaskRequest) {
	request = &StopStreamAnalyseTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("imm", "2017-09-06", "StopStreamAnalyseTask", "imm", "openAPI")
	request.Method = requests.POST
	return
}

// CreateStopStreamAnalyseTaskResponse creates a response to parse from StopStreamAnalyseTask response
func CreateStopStreamAnalyseTaskResponse() (response *StopStreamAnalyseTaskResponse) {
	response = &StopStreamAnalyseTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
