package outboundbot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateScript invokes the outboundbot.CreateScript API synchronously
// api document: https://help.aliyun.com/api/outboundbot/createscript.html
func (client *Client) CreateScript(request *CreateScriptRequest) (response *CreateScriptResponse, err error) {
	response = CreateCreateScriptResponse()
	err = client.DoAction(request, response)
	return
}

// CreateScriptWithChan invokes the outboundbot.CreateScript API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/createscript.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateScriptWithChan(request *CreateScriptRequest) (<-chan *CreateScriptResponse, <-chan error) {
	responseChan := make(chan *CreateScriptResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateScript(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateScriptWithCallback invokes the outboundbot.CreateScript API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/createscript.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateScriptWithCallback(request *CreateScriptRequest, callback func(response *CreateScriptResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateScriptResponse
		var err error
		defer close(result)
		response, err = client.CreateScript(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateScriptRequest is the request struct for api CreateScript
type CreateScriptRequest struct {
	*requests.RpcRequest
	TtsConfig         string `position:"Query" name:"TtsConfig"`
	Industry          string `position:"Query" name:"Industry"`
	ScriptName        string `position:"Query" name:"ScriptName"`
	Scene             string `position:"Query" name:"Scene"`
	ChatbotId         string `position:"Query" name:"ChatbotId"`
	InstanceId        string `position:"Query" name:"InstanceId"`
	AsrConfig         string `position:"Query" name:"AsrConfig"`
	ScriptDescription string `position:"Query" name:"ScriptDescription"`
}

// CreateScriptResponse is the response struct for api CreateScript
type CreateScriptResponse struct {
	*responses.BaseResponse
	Code           string `json:"Code" xml:"Code"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string `json:"Message" xml:"Message"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
	ChatbotId      string `json:"ChatbotId" xml:"ChatbotId"`
	Script         Script `json:"Script" xml:"Script"`
}

// CreateCreateScriptRequest creates a request to invoke CreateScript API
func CreateCreateScriptRequest() (request *CreateScriptRequest) {
	request = &CreateScriptRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("OutboundBot", "2019-12-26", "CreateScript", "outboundbot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateScriptResponse creates a response to parse from CreateScript response
func CreateCreateScriptResponse() (response *CreateScriptResponse) {
	response = &CreateScriptResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
