package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateDedicatedHostAccount invokes the rds.CreateDedicatedHostAccount API synchronously
// api document: https://help.aliyun.com/api/rds/creatededicatedhostaccount.html
func (client *Client) CreateDedicatedHostAccount(request *CreateDedicatedHostAccountRequest) (response *CreateDedicatedHostAccountResponse, err error) {
	response = CreateCreateDedicatedHostAccountResponse()
	err = client.DoAction(request, response)
	return
}

// CreateDedicatedHostAccountWithChan invokes the rds.CreateDedicatedHostAccount API asynchronously
// api document: https://help.aliyun.com/api/rds/creatededicatedhostaccount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateDedicatedHostAccountWithChan(request *CreateDedicatedHostAccountRequest) (<-chan *CreateDedicatedHostAccountResponse, <-chan error) {
	responseChan := make(chan *CreateDedicatedHostAccountResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateDedicatedHostAccount(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateDedicatedHostAccountWithCallback invokes the rds.CreateDedicatedHostAccount API asynchronously
// api document: https://help.aliyun.com/api/rds/creatededicatedhostaccount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateDedicatedHostAccountWithCallback(request *CreateDedicatedHostAccountRequest, callback func(response *CreateDedicatedHostAccountResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateDedicatedHostAccountResponse
		var err error
		defer close(result)
		response, err = client.CreateDedicatedHostAccount(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateDedicatedHostAccountRequest is the request struct for api CreateDedicatedHostAccount
type CreateDedicatedHostAccountRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	AccountName          string           `position:"Query" name:"AccountName"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	DedicatedHostId      string           `position:"Query" name:"DedicatedHostId"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	AccountPassword      string           `position:"Query" name:"AccountPassword"`
}

// CreateDedicatedHostAccountResponse is the response struct for api CreateDedicatedHostAccount
type CreateDedicatedHostAccountResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCreateDedicatedHostAccountRequest creates a request to invoke CreateDedicatedHostAccount API
func CreateCreateDedicatedHostAccountRequest() (request *CreateDedicatedHostAccountRequest) {
	request = &CreateDedicatedHostAccountRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "CreateDedicatedHostAccount", "rds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateDedicatedHostAccountResponse creates a response to parse from CreateDedicatedHostAccount response
func CreateCreateDedicatedHostAccountResponse() (response *CreateDedicatedHostAccountResponse) {
	response = &CreateDedicatedHostAccountResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
