package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateHostAccount invokes the rds.CreateHostAccount API synchronously
// api document: https://help.aliyun.com/api/rds/createhostaccount.html
func (client *Client) CreateHostAccount(request *CreateHostAccountRequest) (response *CreateHostAccountResponse, err error) {
	response = CreateCreateHostAccountResponse()
	err = client.DoAction(request, response)
	return
}

// CreateHostAccountWithChan invokes the rds.CreateHostAccount API asynchronously
// api document: https://help.aliyun.com/api/rds/createhostaccount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateHostAccountWithChan(request *CreateHostAccountRequest) (<-chan *CreateHostAccountResponse, <-chan error) {
	responseChan := make(chan *CreateHostAccountResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateHostAccount(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateHostAccountWithCallback invokes the rds.CreateHostAccount API asynchronously
// api document: https://help.aliyun.com/api/rds/createhostaccount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateHostAccountWithCallback(request *CreateHostAccountRequest, callback func(response *CreateHostAccountResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateHostAccountResponse
		var err error
		defer close(result)
		response, err = client.CreateHostAccount(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateHostAccountRequest is the request struct for api CreateHostAccount
type CreateHostAccountRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	AccountType          string           `position:"Query" name:"AccountType"`
	AccountDescription   string           `position:"Query" name:"AccountDescription"`
	AccountName          string           `position:"Query" name:"AccountName"`
	DBInstanceId         string           `position:"Query" name:"DBInstanceId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	AccountPassword      string           `position:"Query" name:"AccountPassword"`
}

// CreateHostAccountResponse is the response struct for api CreateHostAccount
type CreateHostAccountResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCreateHostAccountRequest creates a request to invoke CreateHostAccount API
func CreateCreateHostAccountRequest() (request *CreateHostAccountRequest) {
	request = &CreateHostAccountRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "CreateHostAccount", "rds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateHostAccountResponse creates a response to parse from CreateHostAccount response
func CreateCreateHostAccountResponse() (response *CreateHostAccountResponse) {
	response = &CreateHostAccountResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
