package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteDedicatedHostAccount invokes the rds.DeleteDedicatedHostAccount API synchronously
// api document: https://help.aliyun.com/api/rds/deletededicatedhostaccount.html
func (client *Client) DeleteDedicatedHostAccount(request *DeleteDedicatedHostAccountRequest) (response *DeleteDedicatedHostAccountResponse, err error) {
	response = CreateDeleteDedicatedHostAccountResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteDedicatedHostAccountWithChan invokes the rds.DeleteDedicatedHostAccount API asynchronously
// api document: https://help.aliyun.com/api/rds/deletededicatedhostaccount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteDedicatedHostAccountWithChan(request *DeleteDedicatedHostAccountRequest) (<-chan *DeleteDedicatedHostAccountResponse, <-chan error) {
	responseChan := make(chan *DeleteDedicatedHostAccountResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteDedicatedHostAccount(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteDedicatedHostAccountWithCallback invokes the rds.DeleteDedicatedHostAccount API asynchronously
// api document: https://help.aliyun.com/api/rds/deletededicatedhostaccount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteDedicatedHostAccountWithCallback(request *DeleteDedicatedHostAccountRequest, callback func(response *DeleteDedicatedHostAccountResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteDedicatedHostAccountResponse
		var err error
		defer close(result)
		response, err = client.DeleteDedicatedHostAccount(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteDedicatedHostAccountRequest is the request struct for api DeleteDedicatedHostAccount
type DeleteDedicatedHostAccountRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	DedicatedHostId      string           `position:"Query" name:"DedicatedHostId"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	AccountName          string           `position:"Query" name:"AccountName"`
}

// DeleteDedicatedHostAccountResponse is the response struct for api DeleteDedicatedHostAccount
type DeleteDedicatedHostAccountResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteDedicatedHostAccountRequest creates a request to invoke DeleteDedicatedHostAccount API
func CreateDeleteDedicatedHostAccountRequest() (request *DeleteDedicatedHostAccountRequest) {
	request = &DeleteDedicatedHostAccountRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "DeleteDedicatedHostAccount", "rds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteDedicatedHostAccountResponse creates a response to parse from DeleteDedicatedHostAccount response
func CreateDeleteDedicatedHostAccountResponse() (response *DeleteDedicatedHostAccountResponse) {
	response = &DeleteDedicatedHostAccountResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
