package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDedicatedHostImageCategories invokes the rds.DescribeDedicatedHostImageCategories API synchronously
// api document: https://help.aliyun.com/api/rds/describededicatedhostimagecategories.html
func (client *Client) DescribeDedicatedHostImageCategories(request *DescribeDedicatedHostImageCategoriesRequest) (response *DescribeDedicatedHostImageCategoriesResponse, err error) {
	response = CreateDescribeDedicatedHostImageCategoriesResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDedicatedHostImageCategoriesWithChan invokes the rds.DescribeDedicatedHostImageCategories API asynchronously
// api document: https://help.aliyun.com/api/rds/describededicatedhostimagecategories.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDedicatedHostImageCategoriesWithChan(request *DescribeDedicatedHostImageCategoriesRequest) (<-chan *DescribeDedicatedHostImageCategoriesResponse, <-chan error) {
	responseChan := make(chan *DescribeDedicatedHostImageCategoriesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDedicatedHostImageCategories(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDedicatedHostImageCategoriesWithCallback invokes the rds.DescribeDedicatedHostImageCategories API asynchronously
// api document: https://help.aliyun.com/api/rds/describededicatedhostimagecategories.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDedicatedHostImageCategoriesWithCallback(request *DescribeDedicatedHostImageCategoriesRequest, callback func(response *DescribeDedicatedHostImageCategoriesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDedicatedHostImageCategoriesResponse
		var err error
		defer close(result)
		response, err = client.DescribeDedicatedHostImageCategories(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDedicatedHostImageCategoriesRequest is the request struct for api DescribeDedicatedHostImageCategories
type DescribeDedicatedHostImageCategoriesRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	HostGroup            string           `position:"Query" name:"HostGroup"`
}

// DescribeDedicatedHostImageCategoriesResponse is the response struct for api DescribeDedicatedHostImageCategories
type DescribeDedicatedHostImageCategoriesResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Images    Images `json:"Images" xml:"Images"`
}

// CreateDescribeDedicatedHostImageCategoriesRequest creates a request to invoke DescribeDedicatedHostImageCategories API
func CreateDescribeDedicatedHostImageCategoriesRequest() (request *DescribeDedicatedHostImageCategoriesRequest) {
	request = &DescribeDedicatedHostImageCategoriesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "DescribeDedicatedHostImageCategories", "rds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeDedicatedHostImageCategoriesResponse creates a response to parse from DescribeDedicatedHostImageCategories response
func CreateDescribeDedicatedHostImageCategoriesResponse() (response *DescribeDedicatedHostImageCategoriesResponse) {
	response = &DescribeDedicatedHostImageCategoriesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
