package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeNextEventForSign invokes the rds.DescribeNextEventForSign API synchronously
// api document: https://help.aliyun.com/api/rds/describenexteventforsign.html
func (client *Client) DescribeNextEventForSign(request *DescribeNextEventForSignRequest) (response *DescribeNextEventForSignResponse, err error) {
	response = CreateDescribeNextEventForSignResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeNextEventForSignWithChan invokes the rds.DescribeNextEventForSign API asynchronously
// api document: https://help.aliyun.com/api/rds/describenexteventforsign.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeNextEventForSignWithChan(request *DescribeNextEventForSignRequest) (<-chan *DescribeNextEventForSignResponse, <-chan error) {
	responseChan := make(chan *DescribeNextEventForSignResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeNextEventForSign(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeNextEventForSignWithCallback invokes the rds.DescribeNextEventForSign API asynchronously
// api document: https://help.aliyun.com/api/rds/describenexteventforsign.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeNextEventForSignWithCallback(request *DescribeNextEventForSignRequest, callback func(response *DescribeNextEventForSignResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeNextEventForSignResponse
		var err error
		defer close(result)
		response, err = client.DescribeNextEventForSign(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeNextEventForSignRequest is the request struct for api DescribeNextEventForSign
type DescribeNextEventForSignRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeNextEventForSignResponse is the response struct for api DescribeNextEventForSign
type DescribeNextEventForSignResponse struct {
	*responses.BaseResponse
	RequestId  string                               `json:"RequestId" xml:"RequestId"`
	EventItems EventItemsInDescribeNextEventForSign `json:"EventItems" xml:"EventItems"`
}

// CreateDescribeNextEventForSignRequest creates a request to invoke DescribeNextEventForSign API
func CreateDescribeNextEventForSignRequest() (request *DescribeNextEventForSignRequest) {
	request = &DescribeNextEventForSignRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "DescribeNextEventForSign", "rds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeNextEventForSignResponse creates a response to parse from DescribeNextEventForSign response
func CreateDescribeNextEventForSignResponse() (response *DescribeNextEventForSignResponse) {
	response = &DescribeNextEventForSignResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
