package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SignEventAction invokes the rds.SignEventAction API synchronously
// api document: https://help.aliyun.com/api/rds/signeventaction.html
func (client *Client) SignEventAction(request *SignEventActionRequest) (response *SignEventActionResponse, err error) {
	response = CreateSignEventActionResponse()
	err = client.DoAction(request, response)
	return
}

// SignEventActionWithChan invokes the rds.SignEventAction API asynchronously
// api document: https://help.aliyun.com/api/rds/signeventaction.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) SignEventActionWithChan(request *SignEventActionRequest) (<-chan *SignEventActionResponse, <-chan error) {
	responseChan := make(chan *SignEventActionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SignEventAction(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SignEventActionWithCallback invokes the rds.SignEventAction API asynchronously
// api document: https://help.aliyun.com/api/rds/signeventaction.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) SignEventActionWithCallback(request *SignEventActionRequest, callback func(response *SignEventActionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SignEventActionResponse
		var err error
		defer close(result)
		response, err = client.SignEventAction(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SignEventActionRequest is the request struct for api SignEventAction
type SignEventActionRequest struct {
	*requests.RpcRequest
	EventId              requests.Integer `position:"Query" name:"EventId"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	EventSig             string           `position:"Query" name:"EventSig"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// SignEventActionResponse is the response struct for api SignEventAction
type SignEventActionResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	EventId   string `json:"EventId" xml:"EventId"`
	EventRcpt string `json:"EventRcpt" xml:"EventRcpt"`
}

// CreateSignEventActionRequest creates a request to invoke SignEventAction API
func CreateSignEventActionRequest() (request *SignEventActionRequest) {
	request = &SignEventActionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "SignEventAction", "rds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSignEventActionResponse creates a response to parse from SignEventAction response
func CreateSignEventActionResponse() (response *SignEventActionResponse) {
	response = &SignEventActionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
