package rtc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteMAURule invokes the rtc.DeleteMAURule API synchronously
// api document: https://help.aliyun.com/api/rtc/deletemaurule.html
func (client *Client) DeleteMAURule(request *DeleteMAURuleRequest) (response *DeleteMAURuleResponse, err error) {
	response = CreateDeleteMAURuleResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteMAURuleWithChan invokes the rtc.DeleteMAURule API asynchronously
// api document: https://help.aliyun.com/api/rtc/deletemaurule.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteMAURuleWithChan(request *DeleteMAURuleRequest) (<-chan *DeleteMAURuleResponse, <-chan error) {
	responseChan := make(chan *DeleteMAURuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteMAURule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteMAURuleWithCallback invokes the rtc.DeleteMAURule API asynchronously
// api document: https://help.aliyun.com/api/rtc/deletemaurule.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteMAURuleWithCallback(request *DeleteMAURuleRequest, callback func(response *DeleteMAURuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteMAURuleResponse
		var err error
		defer close(result)
		response, err = client.DeleteMAURule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteMAURuleRequest is the request struct for api DeleteMAURule
type DeleteMAURuleRequest struct {
	*requests.RpcRequest
	OwnerId requests.Integer `position:"Query" name:"OwnerId"`
	AppId   string           `position:"Query" name:"AppId"`
	RuleId  requests.Integer `position:"Query" name:"RuleId"`
}

// DeleteMAURuleResponse is the response struct for api DeleteMAURule
type DeleteMAURuleResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteMAURuleRequest creates a request to invoke DeleteMAURule API
func CreateDeleteMAURuleRequest() (request *DeleteMAURuleRequest) {
	request = &DeleteMAURuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("rtc", "2018-01-11", "DeleteMAURule", "rtc", "openAPI")
	return
}

// CreateDeleteMAURuleResponse creates a response to parse from DeleteMAURule response
func CreateDeleteMAURuleResponse() (response *DeleteMAURuleResponse) {
	response = &DeleteMAURuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
