package rtc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DisableMAURule invokes the rtc.DisableMAURule API synchronously
// api document: https://help.aliyun.com/api/rtc/disablemaurule.html
func (client *Client) DisableMAURule(request *DisableMAURuleRequest) (response *DisableMAURuleResponse, err error) {
	response = CreateDisableMAURuleResponse()
	err = client.DoAction(request, response)
	return
}

// DisableMAURuleWithChan invokes the rtc.DisableMAURule API asynchronously
// api document: https://help.aliyun.com/api/rtc/disablemaurule.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DisableMAURuleWithChan(request *DisableMAURuleRequest) (<-chan *DisableMAURuleResponse, <-chan error) {
	responseChan := make(chan *DisableMAURuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DisableMAURule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DisableMAURuleWithCallback invokes the rtc.DisableMAURule API asynchronously
// api document: https://help.aliyun.com/api/rtc/disablemaurule.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DisableMAURuleWithCallback(request *DisableMAURuleRequest, callback func(response *DisableMAURuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DisableMAURuleResponse
		var err error
		defer close(result)
		response, err = client.DisableMAURule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DisableMAURuleRequest is the request struct for api DisableMAURule
type DisableMAURuleRequest struct {
	*requests.RpcRequest
	OwnerId requests.Integer `position:"Query" name:"OwnerId"`
	AppId   string           `position:"Query" name:"AppId"`
	RuleId  requests.Integer `position:"Query" name:"RuleId"`
}

// DisableMAURuleResponse is the response struct for api DisableMAURule
type DisableMAURuleResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDisableMAURuleRequest creates a request to invoke DisableMAURule API
func CreateDisableMAURuleRequest() (request *DisableMAURuleRequest) {
	request = &DisableMAURuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("rtc", "2018-01-11", "DisableMAURule", "rtc", "openAPI")
	return
}

// CreateDisableMAURuleResponse creates a response to parse from DisableMAURule response
func CreateDisableMAURuleResponse() (response *DisableMAURuleResponse) {
	response = &DisableMAURuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
