package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// Authorized invokes the voicenavigator.Authorized API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/authorized.html
func (client *Client) Authorized(request *AuthorizedRequest) (response *AuthorizedResponse, err error) {
	response = CreateAuthorizedResponse()
	err = client.DoAction(request, response)
	return
}

// AuthorizedWithChan invokes the voicenavigator.Authorized API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/authorized.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) AuthorizedWithChan(request *AuthorizedRequest) (<-chan *AuthorizedResponse, <-chan error) {
	responseChan := make(chan *AuthorizedResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.Authorized(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AuthorizedWithCallback invokes the voicenavigator.Authorized API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/authorized.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) AuthorizedWithCallback(request *AuthorizedRequest, callback func(response *AuthorizedResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AuthorizedResponse
		var err error
		defer close(result)
		response, err = client.Authorized(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AuthorizedRequest is the request struct for api Authorized
type AuthorizedRequest struct {
	*requests.RpcRequest
	ConversationId string `position:"Query" name:"ConversationId"`
	InitialContext string `position:"Query" name:"InitialContext"`
	InstanceId     string `position:"Query" name:"InstanceId"`
}

// AuthorizedResponse is the response struct for api Authorized
type AuthorizedResponse struct {
	*responses.BaseResponse
	RequestId     string `json:"RequestId" xml:"RequestId"`
	TextResponse  string `json:"TextResponse" xml:"TextResponse"`
	Interruptible bool   `json:"Interruptible" xml:"Interruptible"`
	Action        string `json:"Action" xml:"Action"`
	ActionParams  string `json:"ActionParams" xml:"ActionParams"`
}

// CreateAuthorizedRequest creates a request to invoke Authorized API
func CreateAuthorizedRequest() (request *AuthorizedRequest) {
	request = &AuthorizedRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "Authorized", "voicebot", "openAPI")
	return
}

// CreateAuthorizedResponse creates a response to parse from Authorized response
func CreateAuthorizedResponse() (response *AuthorizedResponse) {
	response = &AuthorizedResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
