package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchDeleteNavigationScripts invokes the voicenavigator.BatchDeleteNavigationScripts API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/batchdeletenavigationscripts.html
func (client *Client) BatchDeleteNavigationScripts(request *BatchDeleteNavigationScriptsRequest) (response *BatchDeleteNavigationScriptsResponse, err error) {
	response = CreateBatchDeleteNavigationScriptsResponse()
	err = client.DoAction(request, response)
	return
}

// BatchDeleteNavigationScriptsWithChan invokes the voicenavigator.BatchDeleteNavigationScripts API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/batchdeletenavigationscripts.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) BatchDeleteNavigationScriptsWithChan(request *BatchDeleteNavigationScriptsRequest) (<-chan *BatchDeleteNavigationScriptsResponse, <-chan error) {
	responseChan := make(chan *BatchDeleteNavigationScriptsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchDeleteNavigationScripts(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchDeleteNavigationScriptsWithCallback invokes the voicenavigator.BatchDeleteNavigationScripts API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/batchdeletenavigationscripts.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) BatchDeleteNavigationScriptsWithCallback(request *BatchDeleteNavigationScriptsRequest, callback func(response *BatchDeleteNavigationScriptsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchDeleteNavigationScriptsResponse
		var err error
		defer close(result)
		response, err = client.BatchDeleteNavigationScripts(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchDeleteNavigationScriptsRequest is the request struct for api BatchDeleteNavigationScripts
type BatchDeleteNavigationScriptsRequest struct {
	*requests.RpcRequest
	NavigationScriptIds *[]string `position:"Query" name:"NavigationScriptIds"  type:"Repeated"`
	InstanceId          string    `position:"Query" name:"InstanceId"`
}

// BatchDeleteNavigationScriptsResponse is the response struct for api BatchDeleteNavigationScripts
type BatchDeleteNavigationScriptsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateBatchDeleteNavigationScriptsRequest creates a request to invoke BatchDeleteNavigationScripts API
func CreateBatchDeleteNavigationScriptsRequest() (request *BatchDeleteNavigationScriptsRequest) {
	request = &BatchDeleteNavigationScriptsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "BatchDeleteNavigationScripts", "voicebot", "openAPI")
	return
}

// CreateBatchDeleteNavigationScriptsResponse creates a response to parse from BatchDeleteNavigationScripts response
func CreateBatchDeleteNavigationScriptsResponse() (response *BatchDeleteNavigationScriptsResponse) {
	response = &BatchDeleteNavigationScriptsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
