package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchMoveNavigationScripts invokes the voicenavigator.BatchMoveNavigationScripts API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/batchmovenavigationscripts.html
func (client *Client) BatchMoveNavigationScripts(request *BatchMoveNavigationScriptsRequest) (response *BatchMoveNavigationScriptsResponse, err error) {
	response = CreateBatchMoveNavigationScriptsResponse()
	err = client.DoAction(request, response)
	return
}

// BatchMoveNavigationScriptsWithChan invokes the voicenavigator.BatchMoveNavigationScripts API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/batchmovenavigationscripts.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) BatchMoveNavigationScriptsWithChan(request *BatchMoveNavigationScriptsRequest) (<-chan *BatchMoveNavigationScriptsResponse, <-chan error) {
	responseChan := make(chan *BatchMoveNavigationScriptsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchMoveNavigationScripts(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchMoveNavigationScriptsWithCallback invokes the voicenavigator.BatchMoveNavigationScripts API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/batchmovenavigationscripts.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) BatchMoveNavigationScriptsWithCallback(request *BatchMoveNavigationScriptsRequest, callback func(response *BatchMoveNavigationScriptsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchMoveNavigationScriptsResponse
		var err error
		defer close(result)
		response, err = client.BatchMoveNavigationScripts(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchMoveNavigationScriptsRequest is the request struct for api BatchMoveNavigationScripts
type BatchMoveNavigationScriptsRequest struct {
	*requests.RpcRequest
	NavigationScriptIds *[]string `position:"Query" name:"NavigationScriptIds"  type:"Repeated"`
	InstanceId          string    `position:"Query" name:"InstanceId"`
	TargetCategoryId    string    `position:"Query" name:"TargetCategoryId"`
}

// BatchMoveNavigationScriptsResponse is the response struct for api BatchMoveNavigationScripts
type BatchMoveNavigationScriptsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateBatchMoveNavigationScriptsRequest creates a request to invoke BatchMoveNavigationScripts API
func CreateBatchMoveNavigationScriptsRequest() (request *BatchMoveNavigationScriptsRequest) {
	request = &BatchMoveNavigationScriptsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "BatchMoveNavigationScripts", "voicebot", "openAPI")
	return
}

// CreateBatchMoveNavigationScriptsResponse creates a response to parse from BatchMoveNavigationScripts response
func CreateBatchMoveNavigationScriptsResponse() (response *BatchMoveNavigationScriptsResponse) {
	response = &BatchMoveNavigationScriptsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
