package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateKnowledge invokes the voicenavigator.CreateKnowledge API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/createknowledge.html
func (client *Client) CreateKnowledge(request *CreateKnowledgeRequest) (response *CreateKnowledgeResponse, err error) {
	response = CreateCreateKnowledgeResponse()
	err = client.DoAction(request, response)
	return
}

// CreateKnowledgeWithChan invokes the voicenavigator.CreateKnowledge API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/createknowledge.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateKnowledgeWithChan(request *CreateKnowledgeRequest) (<-chan *CreateKnowledgeResponse, <-chan error) {
	responseChan := make(chan *CreateKnowledgeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateKnowledge(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateKnowledgeWithCallback invokes the voicenavigator.CreateKnowledge API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/createknowledge.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateKnowledgeWithCallback(request *CreateKnowledgeRequest, callback func(response *CreateKnowledgeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateKnowledgeResponse
		var err error
		defer close(result)
		response, err = client.CreateKnowledge(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateKnowledgeRequest is the request struct for api CreateKnowledge
type CreateKnowledgeRequest struct {
	*requests.RpcRequest
	UserUtterance     string           `position:"Query" name:"UserUtterance"`
	Interruptible     requests.Boolean `position:"Query" name:"Interruptible"`
	InstanceId        string           `position:"Query" name:"InstanceId"`
	Answer            string           `position:"Query" name:"Answer"`
	SimilarUtterances *[]string        `position:"Query" name:"SimilarUtterances"  type:"Repeated"`
	CategoryId        string           `position:"Query" name:"CategoryId"`
}

// CreateKnowledgeResponse is the response struct for api CreateKnowledge
type CreateKnowledgeResponse struct {
	*responses.BaseResponse
	RequestId          string `json:"RequestId" xml:"RequestId"`
	NavigationScriptId string `json:"NavigationScriptId" xml:"NavigationScriptId"`
}

// CreateCreateKnowledgeRequest creates a request to invoke CreateKnowledge API
func CreateCreateKnowledgeRequest() (request *CreateKnowledgeRequest) {
	request = &CreateKnowledgeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "CreateKnowledge", "voicebot", "openAPI")
	return
}

// CreateCreateKnowledgeResponse creates a response to parse from CreateKnowledge response
func CreateCreateKnowledgeResponse() (response *CreateKnowledgeResponse) {
	response = &CreateKnowledgeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
