package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateRedirection invokes the voicenavigator.CreateRedirection API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/createredirection.html
func (client *Client) CreateRedirection(request *CreateRedirectionRequest) (response *CreateRedirectionResponse, err error) {
	response = CreateCreateRedirectionResponse()
	err = client.DoAction(request, response)
	return
}

// CreateRedirectionWithChan invokes the voicenavigator.CreateRedirection API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/createredirection.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateRedirectionWithChan(request *CreateRedirectionRequest) (<-chan *CreateRedirectionResponse, <-chan error) {
	responseChan := make(chan *CreateRedirectionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateRedirection(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateRedirectionWithCallback invokes the voicenavigator.CreateRedirection API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/createredirection.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateRedirectionWithCallback(request *CreateRedirectionRequest, callback func(response *CreateRedirectionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateRedirectionResponse
		var err error
		defer close(result)
		response, err = client.CreateRedirection(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateRedirectionRequest is the request struct for api CreateRedirection
type CreateRedirectionRequest struct {
	*requests.RpcRequest
	RedirectionType   string           `position:"Query" name:"RedirectionType"`
	UserUtterance     string           `position:"Query" name:"UserUtterance"`
	Interruptible     requests.Boolean `position:"Query" name:"Interruptible"`
	InstanceId        string           `position:"Query" name:"InstanceId"`
	SimilarUtterances *[]string        `position:"Query" name:"SimilarUtterances"  type:"Repeated"`
	RedirectionTarget string           `position:"Query" name:"RedirectionTarget"`
	Prompt            string           `position:"Query" name:"Prompt"`
	CategoryId        string           `position:"Query" name:"CategoryId"`
}

// CreateRedirectionResponse is the response struct for api CreateRedirection
type CreateRedirectionResponse struct {
	*responses.BaseResponse
	RequestId          string `json:"RequestId" xml:"RequestId"`
	NavigationScriptId string `json:"NavigationScriptId" xml:"NavigationScriptId"`
}

// CreateCreateRedirectionRequest creates a request to invoke CreateRedirection API
func CreateCreateRedirectionRequest() (request *CreateRedirectionRequest) {
	request = &CreateRedirectionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "CreateRedirection", "voicebot", "openAPI")
	return
}

// CreateCreateRedirectionResponse creates a response to parse from CreateRedirection response
func CreateCreateRedirectionResponse() (response *CreateRedirectionResponse) {
	response = &CreateRedirectionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
