package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteNavigationScript invokes the voicenavigator.DeleteNavigationScript API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/deletenavigationscript.html
func (client *Client) DeleteNavigationScript(request *DeleteNavigationScriptRequest) (response *DeleteNavigationScriptResponse, err error) {
	response = CreateDeleteNavigationScriptResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteNavigationScriptWithChan invokes the voicenavigator.DeleteNavigationScript API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/deletenavigationscript.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteNavigationScriptWithChan(request *DeleteNavigationScriptRequest) (<-chan *DeleteNavigationScriptResponse, <-chan error) {
	responseChan := make(chan *DeleteNavigationScriptResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteNavigationScript(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteNavigationScriptWithCallback invokes the voicenavigator.DeleteNavigationScript API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/deletenavigationscript.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DeleteNavigationScriptWithCallback(request *DeleteNavigationScriptRequest, callback func(response *DeleteNavigationScriptResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteNavigationScriptResponse
		var err error
		defer close(result)
		response, err = client.DeleteNavigationScript(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteNavigationScriptRequest is the request struct for api DeleteNavigationScript
type DeleteNavigationScriptRequest struct {
	*requests.RpcRequest
	InstanceId         string `position:"Query" name:"InstanceId"`
	NavigationScriptId string `position:"Query" name:"NavigationScriptId"`
}

// DeleteNavigationScriptResponse is the response struct for api DeleteNavigationScript
type DeleteNavigationScriptResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteNavigationScriptRequest creates a request to invoke DeleteNavigationScript API
func CreateDeleteNavigationScriptRequest() (request *DeleteNavigationScriptRequest) {
	request = &DeleteNavigationScriptRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "DeleteNavigationScript", "voicebot", "openAPI")
	return
}

// CreateDeleteNavigationScriptResponse creates a response to parse from DeleteNavigationScript response
func CreateDeleteNavigationScriptResponse() (response *DeleteNavigationScriptResponse) {
	response = &DeleteNavigationScriptResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
