package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeCategoryTree invokes the voicenavigator.DescribeCategoryTree API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/describecategorytree.html
func (client *Client) DescribeCategoryTree(request *DescribeCategoryTreeRequest) (response *DescribeCategoryTreeResponse, err error) {
	response = CreateDescribeCategoryTreeResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeCategoryTreeWithChan invokes the voicenavigator.DescribeCategoryTree API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/describecategorytree.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCategoryTreeWithChan(request *DescribeCategoryTreeRequest) (<-chan *DescribeCategoryTreeResponse, <-chan error) {
	responseChan := make(chan *DescribeCategoryTreeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeCategoryTree(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeCategoryTreeWithCallback invokes the voicenavigator.DescribeCategoryTree API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/describecategorytree.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCategoryTreeWithCallback(request *DescribeCategoryTreeRequest, callback func(response *DescribeCategoryTreeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeCategoryTreeResponse
		var err error
		defer close(result)
		response, err = client.DescribeCategoryTree(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeCategoryTreeRequest is the request struct for api DescribeCategoryTree
type DescribeCategoryTreeRequest struct {
	*requests.RpcRequest
	InstanceId string `position:"Query" name:"InstanceId"`
}

// DescribeCategoryTreeResponse is the response struct for api DescribeCategoryTree
type DescribeCategoryTreeResponse struct {
	*responses.BaseResponse
	RequestId string  `json:"RequestId" xml:"RequestId"`
	Levels    []Level `json:"Levels" xml:"Levels"`
}

// CreateDescribeCategoryTreeRequest creates a request to invoke DescribeCategoryTree API
func CreateDescribeCategoryTreeRequest() (request *DescribeCategoryTreeRequest) {
	request = &DescribeCategoryTreeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "DescribeCategoryTree", "voicebot", "openAPI")
	return
}

// CreateDescribeCategoryTreeResponse creates a response to parse from DescribeCategoryTree response
func CreateDescribeCategoryTreeResponse() (response *DescribeCategoryTreeResponse) {
	response = &DescribeCategoryTreeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
