package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListConversations invokes the voicenavigator.ListConversations API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/listconversations.html
func (client *Client) ListConversations(request *ListConversationsRequest) (response *ListConversationsResponse, err error) {
	response = CreateListConversationsResponse()
	err = client.DoAction(request, response)
	return
}

// ListConversationsWithChan invokes the voicenavigator.ListConversations API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/listconversations.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListConversationsWithChan(request *ListConversationsRequest) (<-chan *ListConversationsResponse, <-chan error) {
	responseChan := make(chan *ListConversationsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListConversations(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListConversationsWithCallback invokes the voicenavigator.ListConversations API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/listconversations.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListConversationsWithCallback(request *ListConversationsRequest, callback func(response *ListConversationsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListConversationsResponse
		var err error
		defer close(result)
		response, err = client.ListConversations(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListConversationsRequest is the request struct for api ListConversations
type ListConversationsRequest struct {
	*requests.RpcRequest
	PageNumber requests.Integer `position:"Query" name:"PageNumber"`
	InstanceId string           `position:"Query" name:"InstanceId"`
	PageSize   requests.Integer `position:"Query" name:"PageSize"`
}

// ListConversationsResponse is the response struct for api ListConversations
type ListConversationsResponse struct {
	*responses.BaseResponse
	RequestId     string         `json:"RequestId" xml:"RequestId"`
	TotalCount    int64          `json:"TotalCount" xml:"TotalCount"`
	PageNumber    int            `json:"PageNumber" xml:"PageNumber"`
	PageSize      int            `json:"PageSize" xml:"PageSize"`
	Conversations []Conversation `json:"Conversations" xml:"Conversations"`
}

// CreateListConversationsRequest creates a request to invoke ListConversations API
func CreateListConversationsRequest() (request *ListConversationsRequest) {
	request = &ListConversationsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "ListConversations", "voicebot", "openAPI")
	return
}

// CreateListConversationsResponse creates a response to parse from ListConversations response
func CreateListConversationsResponse() (response *ListConversationsResponse) {
	response = &ListConversationsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
