package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListNavigationScripts invokes the voicenavigator.ListNavigationScripts API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/listnavigationscripts.html
func (client *Client) ListNavigationScripts(request *ListNavigationScriptsRequest) (response *ListNavigationScriptsResponse, err error) {
	response = CreateListNavigationScriptsResponse()
	err = client.DoAction(request, response)
	return
}

// ListNavigationScriptsWithChan invokes the voicenavigator.ListNavigationScripts API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/listnavigationscripts.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListNavigationScriptsWithChan(request *ListNavigationScriptsRequest) (<-chan *ListNavigationScriptsResponse, <-chan error) {
	responseChan := make(chan *ListNavigationScriptsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListNavigationScripts(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListNavigationScriptsWithCallback invokes the voicenavigator.ListNavigationScripts API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/listnavigationscripts.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListNavigationScriptsWithCallback(request *ListNavigationScriptsRequest, callback func(response *ListNavigationScriptsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListNavigationScriptsResponse
		var err error
		defer close(result)
		response, err = client.ListNavigationScripts(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListNavigationScriptsRequest is the request struct for api ListNavigationScripts
type ListNavigationScriptsRequest struct {
	*requests.RpcRequest
	PageNumber requests.Integer `position:"Query" name:"PageNumber"`
	InstanceId string           `position:"Query" name:"InstanceId"`
	PageSize   requests.Integer `position:"Query" name:"PageSize"`
	CategoryId string           `position:"Query" name:"CategoryId"`
}

// ListNavigationScriptsResponse is the response struct for api ListNavigationScripts
type ListNavigationScriptsResponse struct {
	*responses.BaseResponse
	RequestId         string             `json:"RequestId" xml:"RequestId"`
	TotalCount        int64              `json:"TotalCount" xml:"TotalCount"`
	PageNumber        int                `json:"PageNumber" xml:"PageNumber"`
	PageSize          int                `json:"PageSize" xml:"PageSize"`
	NavigationScripts []NavigationScript `json:"NavigationScripts" xml:"NavigationScripts"`
}

// CreateListNavigationScriptsRequest creates a request to invoke ListNavigationScripts API
func CreateListNavigationScriptsRequest() (request *ListNavigationScriptsRequest) {
	request = &ListNavigationScriptsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "ListNavigationScripts", "voicebot", "openAPI")
	return
}

// CreateListNavigationScriptsResponse creates a response to parse from ListNavigationScripts response
func CreateListNavigationScriptsResponse() (response *ListNavigationScriptsResponse) {
	response = &ListNavigationScriptsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
