package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyComplainingConfig invokes the voicenavigator.ModifyComplainingConfig API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/modifycomplainingconfig.html
func (client *Client) ModifyComplainingConfig(request *ModifyComplainingConfigRequest) (response *ModifyComplainingConfigResponse, err error) {
	response = CreateModifyComplainingConfigResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyComplainingConfigWithChan invokes the voicenavigator.ModifyComplainingConfig API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/modifycomplainingconfig.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyComplainingConfigWithChan(request *ModifyComplainingConfigRequest) (<-chan *ModifyComplainingConfigResponse, <-chan error) {
	responseChan := make(chan *ModifyComplainingConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyComplainingConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyComplainingConfigWithCallback invokes the voicenavigator.ModifyComplainingConfig API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/modifycomplainingconfig.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyComplainingConfigWithCallback(request *ModifyComplainingConfigRequest, callback func(response *ModifyComplainingConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyComplainingConfigResponse
		var err error
		defer close(result)
		response, err = client.ModifyComplainingConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyComplainingConfigRequest is the request struct for api ModifyComplainingConfig
type ModifyComplainingConfigRequest struct {
	*requests.RpcRequest
	Utterances        *[]string `position:"Query" name:"Utterances"  type:"Repeated"`
	FinalAction       string    `position:"Query" name:"FinalAction"`
	InstanceId        string    `position:"Query" name:"InstanceId"`
	FinalActionParams string    `position:"Query" name:"FinalActionParams"`
	Prompt            string    `position:"Query" name:"Prompt"`
}

// ModifyComplainingConfigResponse is the response struct for api ModifyComplainingConfig
type ModifyComplainingConfigResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyComplainingConfigRequest creates a request to invoke ModifyComplainingConfig API
func CreateModifyComplainingConfigRequest() (request *ModifyComplainingConfigRequest) {
	request = &ModifyComplainingConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "ModifyComplainingConfig", "voicebot", "openAPI")
	return
}

// CreateModifyComplainingConfigResponse creates a response to parse from ModifyComplainingConfig response
func CreateModifyComplainingConfigResponse() (response *ModifyComplainingConfigResponse) {
	response = &ModifyComplainingConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
