package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyRedirection invokes the voicenavigator.ModifyRedirection API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/modifyredirection.html
func (client *Client) ModifyRedirection(request *ModifyRedirectionRequest) (response *ModifyRedirectionResponse, err error) {
	response = CreateModifyRedirectionResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyRedirectionWithChan invokes the voicenavigator.ModifyRedirection API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/modifyredirection.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyRedirectionWithChan(request *ModifyRedirectionRequest) (<-chan *ModifyRedirectionResponse, <-chan error) {
	responseChan := make(chan *ModifyRedirectionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyRedirection(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyRedirectionWithCallback invokes the voicenavigator.ModifyRedirection API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/modifyredirection.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyRedirectionWithCallback(request *ModifyRedirectionRequest, callback func(response *ModifyRedirectionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyRedirectionResponse
		var err error
		defer close(result)
		response, err = client.ModifyRedirection(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyRedirectionRequest is the request struct for api ModifyRedirection
type ModifyRedirectionRequest struct {
	*requests.RpcRequest
	RedirectionType    string           `position:"Query" name:"RedirectionType"`
	UserUtterance      string           `position:"Query" name:"UserUtterance"`
	Interruptible      requests.Boolean `position:"Query" name:"Interruptible"`
	InstanceId         string           `position:"Query" name:"InstanceId"`
	NavigationScriptId string           `position:"Query" name:"NavigationScriptId"`
	SimilarUtterances  *[]string        `position:"Query" name:"SimilarUtterances"  type:"Repeated"`
	RedirectionTarget  string           `position:"Query" name:"RedirectionTarget"`
	Prompt             string           `position:"Query" name:"Prompt"`
}

// ModifyRedirectionResponse is the response struct for api ModifyRedirection
type ModifyRedirectionResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyRedirectionRequest creates a request to invoke ModifyRedirection API
func CreateModifyRedirectionRequest() (request *ModifyRedirectionRequest) {
	request = &ModifyRedirectionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "ModifyRedirection", "voicebot", "openAPI")
	return
}

// CreateModifyRedirectionResponse creates a response to parse from ModifyRedirection response
func CreateModifyRedirectionResponse() (response *ModifyRedirectionResponse) {
	response = &ModifyRedirectionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
