package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// MoveCategory invokes the voicenavigator.MoveCategory API synchronously
// api document: https://help.aliyun.com/api/voicenavigator/movecategory.html
func (client *Client) MoveCategory(request *MoveCategoryRequest) (response *MoveCategoryResponse, err error) {
	response = CreateMoveCategoryResponse()
	err = client.DoAction(request, response)
	return
}

// MoveCategoryWithChan invokes the voicenavigator.MoveCategory API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/movecategory.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) MoveCategoryWithChan(request *MoveCategoryRequest) (<-chan *MoveCategoryResponse, <-chan error) {
	responseChan := make(chan *MoveCategoryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.MoveCategory(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// MoveCategoryWithCallback invokes the voicenavigator.MoveCategory API asynchronously
// api document: https://help.aliyun.com/api/voicenavigator/movecategory.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) MoveCategoryWithCallback(request *MoveCategoryRequest, callback func(response *MoveCategoryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *MoveCategoryResponse
		var err error
		defer close(result)
		response, err = client.MoveCategory(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// MoveCategoryRequest is the request struct for api MoveCategory
type MoveCategoryRequest struct {
	*requests.RpcRequest
	InstanceId              string `position:"Query" name:"InstanceId"`
	TargetPreviousSiblingId string `position:"Query" name:"TargetPreviousSiblingId"`
	TargetParentId          string `position:"Query" name:"TargetParentId"`
	CategoryId              string `position:"Query" name:"CategoryId"`
}

// MoveCategoryResponse is the response struct for api MoveCategory
type MoveCategoryResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateMoveCategoryRequest creates a request to invoke MoveCategory API
func CreateMoveCategoryRequest() (request *MoveCategoryRequest) {
	request = &MoveCategoryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "MoveCategory", "voicebot", "openAPI")
	return
}

// CreateMoveCategoryResponse creates a response to parse from MoveCategory response
func CreateMoveCategoryResponse() (response *MoveCategoryResponse) {
	response = &MoveCategoryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
